=head
	包    名: DataBaseInfoUp.pm
	编码人员: 洪柏青
	功    能: 计算铜面积模块
	编码时间: 2022-12-02
=cut

package DataBaseInfoUp;

use strict;
use warnings;

use utf8;

=head
466	7	面积TL(含板边)%
466	3	面积C面(含板边)
10	3	副靶孔
466	9	面积BL(含板边)%
466	4	面积S面(含板边)

10	1	通孔xray(方形靶标)
10	2	盘中孔(菱形靶标)

120	0	内层铜损(平均%)
484	5	平均沉金面积
484	6	总和沉金面积
484	4	裸铜比例
484	7	总和裸铜比例
497	2	测试点数
0	1	盲孔子板钻带
0	0	genesis层清单
528	1	铣边长
528	2	铣边宽
=cut
#--插入基本信息
sub upLoadBaseInfoToMes{
	my $self   = shift;
	my $job    = uc($self->{Job});
    
	#$self->get_qingda_connect();
	$self->get_MSSQL_connect('192.168.0.58,8588','DATABASE4QD','EMS4QD','EMSPW4QD+2016');
	if ($self->{MsSql}{dbh} !~ /dbi/i) {
		print "no conect database\n";
		$self->pauseMessage("提醒","上传基本信息时连接 MES 数据库失败!",300,300);
		return;
	}else{
		print "Conect ok\n";
	}

    #--删除旧的记录 
    $self->sqlExecuteMsSql("delete from T_GS_OutInfoList  where Pdctno_ = \'$job\'");

	my $Keyin = $self->{hostname};
    #--Techno_: 00,Itemno_: 000,Itemname_: genesis层清单  获取层全部层名称
	my $allLayer = "";

	my $matrix = $self->{matrix};
	foreach my $layer (sort {$matrix->{$a}{row} <=> $matrix->{$b}{row}} keys %{$matrix}) {
		$allLayer .= "*".$layer."*,",
	}
	chop $allLayer;

	my $insertSql;

	#print "$allLayer\n";
    #1--466	7	面积TL(含板边)%
	if (exists $self->{upMesInfo}{tl_percent}) {
		$insertSql  = "insert into T_GS_OutInfoList(Pdctno_,Techno_,Itemno_,Itemname_,Itempara_,Displayord_,Keyin_,Indate_) 
	                 values(\'$job\',\'466\',\'0007\',\'面积TL(含板边)%\',\'$self->{upMesInfo}{tl_percent}\',0,\'$Keyin\',getdate\(\))"; 
		print "$insertSql\n";
		$self->sqlExecuteMsSql($insertSql);
	}


    #2--466	3	面积C面(含板边)
	if (exists $self->{upMesInfo}{tl_total}) {
		$insertSql  = "insert into T_GS_OutInfoList(Pdctno_,Techno_,Itemno_,Itemname_,Itempara_,Displayord_,Keyin_,Indate_) 
	                 values(\'$job\',\'466\',\'0003\',\'面积C面(含板边)\',\'$self->{upMesInfo}{tl_total}\',0,\'$Keyin\',getdate\(\))"; 
		print "$insertSql\n";
		$self->sqlExecuteMsSql($insertSql);
	}


    #3--10	3	副靶孔
	if (exists $self->{upMesInfo}{back_target}) {
		$insertSql  = "insert into T_GS_OutInfoList(Pdctno_,Techno_,Itemno_,Itemname_,Itempara_,Displayord_,Keyin_,Indate_) 
	                 values(\'$job\',\'10\',\'0003\',\'副靶孔\',\'$self->{upMesInfo}{back_target}\',0,\'$Keyin\',getdate\(\))"; 
		print "$insertSql\n";
		$self->sqlExecuteMsSql($insertSql);
	}

    #4--466	9	面积BL(含板边)%
	if (exists $self->{upMesInfo}{bl_percent}) {
		$insertSql  = "insert into T_GS_OutInfoList(Pdctno_,Techno_,Itemno_,Itemname_,Itempara_,Displayord_,Keyin_,Indate_) 
	                 values(\'$job\',\'466\',\'0009\',\'面积BL(含板边)%\',\'$self->{upMesInfo}{bl_percent}\',0,\'$Keyin\',getdate\(\))"; 
		print "$insertSql\n";
		$self->sqlExecuteMsSql($insertSql);
	}


    #5--466	4	面积S面(含板边)
	if (exists $self->{upMesInfo}{bl_total}) {
		$insertSql  = "insert into T_GS_OutInfoList(Pdctno_,Techno_,Itemno_,Itemname_,Itempara_,Displayord_,Keyin_,Indate_) 
	                 values(\'$job\',\'466\',\'0004\',\'面积S面(含板边)\',\'$self->{upMesInfo}{bl_total}\',0,\'$Keyin\',getdate\(\))"; 
		print "$insertSql\n";
		$self->sqlExecuteMsSql($insertSql);
	}



    #6--10	1	通孔xray(方形靶标)
	if (exists $self->{upMesInfo}{all_xray}) {
		$insertSql  = "insert into T_GS_OutInfoList(Pdctno_,Techno_,Itemno_,Itemname_,Itempara_,Displayord_,Keyin_,Indate_) 
	                 values(\'$job\',\'10\',\'0001\',\'通孔xray(方形靶标)\',\'$self->{upMesInfo}{all_xray}\',0,\'$Keyin\',getdate\(\))"; 
		print "$insertSql\n";
		$self->sqlExecuteMsSql($insertSql);
	}


	
    #7--10	2	盘中孔(菱形靶标)
	if (exists $self->{upMesInfo}{pzk_xray}) {
		$insertSql  = "insert into T_GS_OutInfoList(Pdctno_,Techno_,Itemno_,Itemname_,Itempara_,Displayord_,Keyin_,Indate_) 
	                 values(\'$job\',\'10\',\'0002\',\'盘中孔(菱形靶标)\',\'$self->{upMesInfo}{pzk_xray}\',0,\'$Keyin\',getdate\(\))"; 
		print "$insertSql\n";
		$self->sqlExecuteMsSql($insertSql);
	}


    #497	2	测试点数
    #0	1	盲孔子板钻带

    #8--120	0	内层铜损(平均%)
	if ($self->{upMesInfo}{inner_tonshun} > 0) {
		$insertSql  = "insert into T_GS_OutInfoList(Pdctno_,Techno_,Itemno_,Itemname_,Itempara_,Displayord_,Keyin_,Indate_) 
	                 values(\'$job\',\'120\',\'0000\',\'内层铜损(平均%)\',\'$self->{upMesInfo}{inner_tonshun}\',0,\'$Keyin\',getdate\(\))"; 
		print "$insertSql\n";
		$self->sqlExecuteMsSql($insertSql);
	}



    #9--484	5	平均沉金面积
	if (exists $self->{upMesInfo}{golAllpinj}) {
		$insertSql  = "insert into T_GS_OutInfoList(Pdctno_,Techno_,Itemno_,Itemname_,Itempara_,Displayord_,Keyin_,Indate_) 
	                 values(\'$job\',\'484\',\'0005\',\'平均沉金面积\',\'$self->{upMesInfo}{golAllpinj}\',0,\'$Keyin\',getdate\(\))"; 
		print "$insertSql\n";
		$self->sqlExecuteMsSql($insertSql);
	}


    #10--484	6	总和沉金面积
	if (exists $self->{upMesInfo}{goldAllTotal}) {
		$insertSql  = "insert into T_GS_OutInfoList(Pdctno_,Techno_,Itemno_,Itemname_,Itempara_,Displayord_,Keyin_,Indate_) 
	                 values(\'$job\',\'484\',\'0006\',\'总和沉金面积\',\'$self->{upMesInfo}{goldAllTotal}\',0,\'$Keyin\',getdate\(\))"; 
		print "$insertSql\n";
	    $self->sqlExecuteMsSql($insertSql);
	}


    #11--484	4	裸铜比例 平均面积
	my $pingjunluotong = sprintf("%.3f",$self->{upMesInfo}{goldAllTotal} / 2);
	$insertSql  = "insert into T_GS_OutInfoList(Pdctno_,Techno_,Itemno_,Itemname_,Itempara_,Displayord_,Keyin_,Indate_) 
	                 values(\'$job\',\'484\',\'0004\',\'裸铜比例\',\'$pingjunluotong\',0,\'$Keyin\',getdate\(\))"; 
	#print "$insertSql\n";
    $self->sqlExecuteMsSql($insertSql);


    #12--484	7	总和裸铜比例
	my $pingjunluotongScale = sprintf("%.3f",$self->{upMesInfo}{golAllpinj} * 2);
	$insertSql  = "insert into T_GS_OutInfoList(Pdctno_,Techno_,Itemno_,Itemname_,Itempara_,Displayord_,Keyin_,Indate_) 
	                 values(\'$job\',\'484\',\'0007\',\'总和裸铜比例\',\'$pingjunluotongScale\',0,\'$Keyin\',getdate\(\))"; 
	#print "$insertSql\n";
    $self->sqlExecuteMsSql($insertSql);


    #13--0	0	genesis层清单
	my $insertLaySql  = "insert into T_GS_OutInfoList(Pdctno_,Techno_,Itemno_,Itemname_,Itempara_,Displayord_,Keyin_,Indate_) 
	                 values(\'$job\',\'00\',\'0000\',\'genesis层清单\',\'$allLayer\',0,\'$Keyin\',getdate\(\))"; 
	print "$insertLaySql\n";
    $self->sqlExecuteMsSql($insertLaySql);
	

    #14--528	1	铣边长
	if (exists $self->{jobRunPnlInfo}{luo_y_length}) {
		$insertSql  = "insert into T_GS_OutInfoList(Pdctno_,Techno_,Itemno_,Itemname_,Itempara_,Displayord_,Keyin_,Indate_) 
	                 values(\'$job\',\'528\',\'0001\',\'铣边长\',\'$self->{jobRunPnlInfo}{luo_y_length}\',0,\'$Keyin\',getdate\(\))"; 
		print "$insertSql\n";
		$self->sqlExecuteMsSql($insertSql);
	}

	#$self->{jobRunPnlInfo}{}
    #15--528	2	铣边宽
	if (exists $self->{jobRunPnlInfo}{luo_x_length}) {
		$insertSql  = "insert into T_GS_OutInfoList(Pdctno_,Techno_,Itemno_,Itemname_,Itempara_,Displayord_,Keyin_,Indate_) 
	                 values(\'$job\',\'528\',\'0002\',\'铣边宽\',\'$self->{jobRunPnlInfo}{luo_x_length}\',0,\'$Keyin\',getdate\(\))"; 
		print "$insertSql\n";
		$self->sqlExecuteMsSql($insertSql);
	}

	
	#--断开连接
	$self->disconnectMsSql();
}

1;

