#!/usr/bin/perl

=head
     01/29/16 HongBaiQing
=cut

package DialogSelectMode;

use strict;
use warnings;
use Win32::API;

sub set_windows_up_down{#--临时设定 windows
	my $self   = shift;
	my $mw     = shift;
	my $mode   = shift;
	$mw->update;
    if ($mode =~ /down/) {
	    Win32::API->new("user32","SetWindowPos",[qw(N N N N N N N)],'N')->Call(hex($mw->frame()),-2,0,0,0,0,3);
    }else{
		Win32::API->new("user32","SetWindowPos",[qw(N N N N N N N)],'N')->Call(hex($mw->frame()),-1,0,0,0,0,3);
	}
}

#--先把 输出资料分类选择 勾选全部去掉 
sub auto_reset_modeselect{
	my $self   = shift @_;
	my ($list,$mode,$dialog) =    @_;

	#***%%%%%%%%%%%********输出资料分类选择
	# 1喷墨字符print_part  2菲林文件film_part 3输出原稿orig_part 4钢网文件gangwan_part 5内层横料&6内层直料inner_hen_shu  7内层inner_part 8锣边rout_part 
	# 9外层outer_part 10外层LDI=ldiout_part 11防焊=mask_part 12字符=silk_part 13蓝胶Set=nanjiaoset_part 14蓝胶Panel=nanjiaopanel_part
	# 15碳油=tanyou_part 16出货菲林=chuhuafilm
	my @allMode = qw/print_part film_part orig_part gangwan_part inner_part rout_part 
	outer_part ldiout_part mask_part silk_part nanjiaoset_part nanjiaopanel_part tanyou_part chuhuafilm/;
	foreach my $key (@allMode) {
		if ($key !~ /$mode/) {
			$dialog->{$key} = 0;
		}
	}

	if ($dialog->{inner_part} == 0) {#--如果没有选内层，内层横料&6内层直料设为 null
		$dialog->{inner_hen_shu} = 'null';
	}

	#***%%%%%%%%%%%********钻孔分类选择
	# 1钻孔=drill_part 2孔图=drill_map 3添加尾孔=add_lasthole 4生成钻咀表=add_table
	my @allDRLMode = qw/drill_part drill_map add_lasthole add_table/;
	foreach my $key (@allDRLMode) {
		if ($key !~ /$mode/) {
			$dialog->{$key} = 0;
		}
	}

	#--11   输出钢网   出货  原稿   文件   不用默认输出 TGZ文件
	if ($dialog->{gangwan_part}  == 1 || $dialog->{chuhuafilm}  == 1 || $dialog->{orig_part}  == 1) {
		$dialog->{tgz_part}  = 0; 
	}else{
		#默认输出 TGZ文件
		$dialog->{tgz_part}  = 1; 
	}
}

#----设置自动选层 
sub auto_select_layer{
	my $self   = shift @_;
	my ($list,$mode,$dialog) =    @_;

	my $isClearAll = 1;
	if ($dialog->{film_part} == 1  && $mode =~ /ldiout_part/) {
		$isClearAll = 0;
	}

	if ($dialog->{drill_part} == 1 && $mode =~ /drill_map/) {
		$isClearAll = 0;
	}


	#---全部清空后重置
	if ($isClearAll) {
		#--先把 输出资料分类选择 勾选全部去掉  
		$self->auto_reset_modeselect($list,$mode,$dialog);  
		#--全部层重置
		foreach my $layer (sort {$list->{$a}{row} <=> $list->{$b}{row}} keys %{$list}) {
			$list->{$layer}{sel} = 0;
		}  
	}


	#---外层ldi与外层同步选中
	if ($mode =~ /outer_part/) {
		if ($dialog->{$mode}) {
			$dialog->{ldiout_part} = 1;
			#---自动判断正负片
			if ($dialog->{step_name} =~ /panel/) {
				$self->get_outer_zf($dialog,$list,$dialog->{step_name});
			}			
		}
	}
	if ($mode =~ /ldiout_part/) {
		if ($dialog->{$mode}) {
			$dialog->{outer_part} = 1;
		}
	}

	if ($mode =~ /film_part/) {
		if ($dialog->{film_part}) {
			$dialog->{ldiout_part} = 1;
		} 
	}

	if ($dialog->{ldiout_part} == 1 || $dialog->{outer_part} == 1) {
		#---自动判断正负片
		if ($dialog->{step_name} =~ /panel/) {
			$self->get_outer_zf($dialog,$list,$dialog->{step_name});
		}
	}

	#--网比
	if ($mode =~ /outer_part|ldiout_part|inner_part/ ) {
		if ($dialog->{$mode}) {
			#$dialog->{net_compare}  = 1;  #---客要求输出线路不要网络比
		}
		elsif ($dialog->{outer_part} ==0 && $dialog->{ldiout_part} ==0 && $dialog->{inner_part} ==0) {
			$dialog->{net_compare}  = 0;   
		}
	}

	if ($mode =~ /gangwan_part/) {
		if ($dialog->{$mode}) {
			$dialog->{rar_part} = 1;
		}
	}


	if ($mode =~ /drill_part/) {
		if ($dialog->{drill_part}) {
			$dialog->{add_lasthole} = 1;
			$dialog->{add_table} = 1;
			$dialog->{drill_map} = 1;
			if ($dialog->{step_name} =~ /panel/) {
				$self->get_outer_zf($dialog,$list,$dialog->{step_name});
			}
		}
		else{
			$dialog->{add_lasthole} = 0;
			$dialog->{add_table} = 0;
			$dialog->{drill_map} = 0;
		}
	}

	if ($mode =~ /orig_part/) {   #---原稿在net输出
		if ($dialog->{orig_part}) {
			if (grep /net/,@{$self->{steplist}}) {
				$dialog->{step_name} = "net";
			}			
		}
	}




	#==========================选取set edit or panel
	foreach my $one (qw/nanjiaoset_part chuhuafilm gangwan_part/) {
		if ($mode =~ /^$one$/) {
			if ($dialog->{$one}) {
				if (grep /set/,@{$self->{steplist}}) {
					foreach my $set (@{$self->{steplist}}) {  #--有可能 set1 set2
						if ($set =~ /set/) {
							$dialog->{step_name} = $set;
							last;                    
						}
					}				
				}
				else{
					if (grep /edit/,@{$self->{steplist}}){
						$dialog->{step_name} = "edit";
					}
				}
			}
		}
	}
	foreach my $one (qw/ldiout_part inner_part outer_part mask_part silk_part tanyou_part 
						nanjiaopanel_part drill_part rout_part print_part zhouqi_part film_part/) {
		if ($mode =~ /$one/) {
			if ($dialog->{$one}) {
				if (grep /^panel$/,@{$self->{steplist}}) {
					$dialog->{step_name} = "panel";
				}
				elsif (grep /panel-b2/,@{$self->{steplist}}) {
					$dialog->{step_name} = "panel-b2";
				}

				if ($dialog->{"B12"} =~ /2/ && grep /panel-b2/,@{$self->{steplist}}) {
					$dialog->{step_name} = "panel-b2";
				}

				if ($dialog->{"B12"} =~ /1/ && grep /^panel$/,@{$self->{steplist}}) {
					$dialog->{step_name} = "panel";
				}

			}
		}
	}
	
	if ($mode =~ /^drill_map$/ && $dialog->{drill_part}==0) {
		if (grep /set/,@{$self->{steplist}}) {
			foreach my $set (@{$self->{steplist}}) {  #--有可能 set1 set2
				if ($set =~ /set/) {
					$dialog->{step_name} = $set;
					last;                    
				}
			}				
		}
		else{
			if (grep /edit/,@{$self->{steplist}}){
				$dialog->{step_name} = "edit";
			}
		}
	}

	#==========================
	if ($mode =~ /drill_part|rout_part|silk_part|print_part|mask_part|outer_part|inner_part|ldiout_part|nanjiaoset_part|drill_map|nanjiaopanel_part|tanyou_part|gangwan_part|chuhuafilm|orig_part|dxf_part|film_part/i) {
		foreach my $layer (sort {$list->{$a}{row} <=> $list->{$b}{row}} keys %{$list}) {	
			if ($list->{$layer}{new_type} =~ /$mode/i) {
				if ($dialog->{$mode}) {
					$list->{$layer}{sel} = 1; 
				}
				else{
					$list->{$layer}{sel} = 0;
				}
			}
		}
		if ($mode =~ /drill_part/i) { #==如是钻孔把孔图也选上
			foreach my $layer (sort {$list->{$a}{row} <=> $list->{$b}{row}} keys %{$list}) {	
				if ($list->{$layer}{new_type} =~ /drill_map/i) {
					if ($dialog->{drill_map}) {
						$list->{$layer}{sel} = 1; 
					}
					else{
						$list->{$layer}{sel} = 0;
					}
				}
			}
		}
	}

	#---在panel只选pin_dim 在不是panel选其它的层
	elsif ($mode =~ /pdf_part/) {
		if ($dialog->{step_name} !~ /panel/) {
			foreach my $layer (sort {$list->{$a}{row} <=> $list->{$b}{row}} keys %{$list}) {
				if ($layer =~ /pin_dim/) {
					next;
				}
				if ($list->{$layer}{new_type} =~ /$mode/i) {
					if ($dialog->{$mode}) {
						$list->{$layer}{sel} = 1; 
					}
					else{
						$list->{$layer}{sel} = 0;
					}
				}
			}
		}
		else{
			foreach my $layer (sort {$list->{$a}{row} <=> $list->{$b}{row}} keys %{$list}) {
				if ($layer !~ /^pin_dim$/) {
					next;
				}
				if ($list->{$layer}{new_type} =~ /$mode/i) {
					if ($dialog->{$mode}) {
						$list->{$layer}{sel} = 1; 
					}
					else{
						$list->{$layer}{sel} = 0;
					}
				}
			}			
		}
	}
	



	elsif ($mode =~ /Clear/i) {
		$dialog->{reread}  = 0;   #--回读对比
		#$dialog->{tgz_part}    = 0;   #--输出 tgz 资料
		$dialog->{pdf_part}  = 0;   #--输出 图纸
		$dialog->{dxf_part}  = 0;   #--输出 图纸
		$dialog->{print_silk}  = 0;   #--字符打印机
		$dialog->{film_part}    = 0; #---菲林
		$dialog->{orig_part}   = 0;   #--原稿
		$dialog->{gangwan_part} = 0;  #--钢网
		$dialog->{inner_hen} = 0 ;   #--内层横料
		$dialog->{inner_shu} = 0 ;   #--内层直料
		$dialog->{inner_part}  = 0;  ##内层线路涨缩
		$dialog->{rout_part}    = 0; #---锣边
		$dialog->{outer_part}  = 0;  ##外层线路涨缩
		$dialog->{ldiout_part} = 0;   #---外层ldi	
		$dialog->{mask_part} = 0;    ##阻 焊 涨 缩
		$dialog->{silk_part}   = 0;  ##文 字 涨 缩
		$dialog->{drill_part}  = 0;  ##钻 带 涨 缩
		$dialog->{add_lasthole} = 0;  #--加尾孔
		$dialog->{add_table} = 0;     #--生成钻咀表
		$dialog->{"2nd_mir"} = 'null';   #--二外从哪面钻
		$dialog->{add_nible_hole} = 0; #--不扩钻
		$dialog->{nanjiaoset_part}  = 0;   #--蓝胶set
		$dialog->{nanjiaopanel_part}  = 0;   #--蓝胶panel
		$dialog->{net_compare}  = 0;   #--网比
		$dialog->{print_part} = 0;  #---字符打印机
		$dialog->{tanyou_part} = 0; #---- 碳油
		$dialog->{zhouqi_part} = 0; #---- 周期
		$dialog->{rar_part} = 0;    #---生成压缩文件
		$dialog->{chuhuafilm} = 0;
		$dialog->{drill_map} = 0;

		
		$dialog->{outer_fz} = "null";  #---外层正负片
		$dialog->{inner_hen_shu} = "null"; #---内层横直料

		if ($dialog->{step_name} =~ /panel/) {
			if ( (grep /^panel$/,@{$self->{steplist}}) && (grep /^panel-b2$/,@{$self->{steplist}}) ) {
				$dialog->{"B12"} = 0;   #---B 1 2 厂
			}
		}
		else{
			$dialog->{"B12"} = 0;   #---B 1 2 厂
		}


		foreach my $layer (sort {$list->{$a}{row} <=> $list->{$b}{row}} keys %{$list}) {
			$list->{$layer}{sel} = 0;
		}
	}
}

#=========层分类===========================
sub fen_layer_type{
	my $self = shift;
	my $list = shift;

	foreach my $layer (sort {$list->{$a}{row} <=> $list->{$b}{row}} keys %{$list}) {
		$list->{$layer}{new_type} = "";
		if ($layer =~ /^tljp$|^bljp$/) {#--蓝胶
			$list->{$layer}{new_type} .= "&nanjiaoset_part";   #---是蓝胶set
			$list->{$layer}{new_type} .= "&nanjiaopanel_part"; #--又做蓝胶panel
			$list->{$layer}{new_type} .= "&chuhuafilm";   #---又是出货film
			#$list->{$layer}{new_type} .= "&film_part";         #--又是film文件
			$list->{$layer}{new_type} .= "gangwan_part";      #----又是钢网
			$list->{$layer}{new_type} .= "&pdf_part";         #---pdf
		}		
		if ($layer =~ /^ttyp$|^btyp$/) {  #---碳油
			$list->{$layer}{new_type} .= "&tanyou_part";   #---是--碳油
			$list->{$layer}{new_type} .= "&chuhuafilm";   #---又是出货film
			$list->{$layer}{new_type} .= "&film_part";         #--又是film文件	
			$list->{$layer}{new_type} .= "&gangwan_part";      #----又是钢网
			$list->{$layer}{new_type} .= "&pdf_part";         #---pdf
		}
		if ($layer =~ /^gto$|^gbo$/i) {
			$list->{$layer}{new_type} .=  "&silk_part";  #--丝印
			$list->{$layer}{new_type} .=  "&print_part";  #--喷墨
			$list->{$layer}{new_type} .= "&chuhuafilm";   #---又是出货film
			$list->{$layer}{new_type} .= "&film_part";         #--又是film文件
			$list->{$layer}{new_type} .= "&gangwan_part";      #----又是钢网
			$list->{$layer}{new_type} .= "&orig_part";         #--原稿
			$list->{$layer}{new_type} .= "&pdf_part";         #---pdf
		}

		if ($layer =~ /^gto-2nd$|^gto-1st$|^gts-1st$|^gts-2nd$|^gbs-1st$|^gbs-2nd$|^gbo-1st$|^gbo-2nd$|^tvcp$|^bvcp$|^tstn$|^bstn$/i) {
			$list->{$layer}{new_type} .= "&film_part";         #--又是film文件
		}


		if ($layer =~ /^panel_rou$|^panel_pin$/i) {  #--锣边
			$list->{$layer}{new_type} .= "&rout_part";
		}
		if ($layer =~ /^gtp$|^gbp$/i) { #----钢网
			$list->{$layer}{new_type} .= "&gangwan_part";
		}
		if ($layer =~ /^gko/i) {
			if ($layer !~ /avi/) {
				$list->{$layer}{new_type} .= "&dxf_part";
				$list->{$layer}{new_type} .= "&film_part";         #--又是film文件
				$list->{$layer}{new_type} .= "&gangwan_part";			
			}			
			
		}
		if ($layer =~ /^gko$|^gtp$|^gbp$|map$/i) {
			if ($layer !~ /vcutmap/) {
				$list->{$layer}{new_type} .= "&gangwan_part";
			}
			if ($layer =~ /^gko$/i) {
				$list->{$layer}{new_type} .= "&film_part";         #--又是film文件
			}
		}
		if ($layer =~ /^pin_dim$/) {
			$list->{$layer}{new_type} .= "&pdf_part";  #--图纸
		}
		if ($layer =~ /map/) {
			if ($layer !~ /cut/) {
				$list->{$layer}{new_type} .= "&drill_map";
			}
			if ($layer !~ /vcutmap/) {
				$list->{$layer}{new_type} .= "&gangwan_part";
				$list->{$layer}{new_type} .= "&chuhuafilm";
			}
		}
		if ( $layer =~ /^drl$|^drl-1st$|^drl-2nd$|^drl-3nd$|^drl\d-\d|^ks\d-\d|^ls\d-\d$/) {
			$list->{$layer}{new_type} .= "&gangwan_part";
		}

	
		if (($list->{$layer}{context} =~ /board/i && $list->{$layer}{layer_type} =~ /drill/i) 
			|| $layer =~ /^drl-1st$|^drl-2nd$|^drl-3nd$|^drl\d-\d|^ks\d-\d|^ls\d-\d$|^nv$/ ) {
			if ($layer !~ /panel_pin/) {
				$list->{$layer}{new_type} .= "&drill_part";
			}
			
			if ($layer =~ /^drl$/) {
				#$list->{$layer}{new_type} .= "orig_part";         #--原稿
			}
		}
		if ($list->{$layer}{context} =~ /board/i && $list->{$layer}{side} =~ /inner/i)  {
			$list->{$layer}{new_type} .= "&inner_part";
			$list->{$layer}{new_type} .= "&chuhuafilm";   #---又是出货film
			$list->{$layer}{new_type} .= "&film_part";    #--又是film文件
			$list->{$layer}{new_type} .= "gangwan_part";  #----又是钢网
			$list->{$layer}{new_type} .= "orig_part";     #--原稿
			$list->{$layer}{new_type} .= "pdf_part";  #--图纸

		}
		if ($list->{$layer}{context} =~ /board/i && $list->{$layer}{layer_type} =~ /signal/i && $list->{$layer}{side} =~ /top|bot/i) {
			$list->{$layer}{new_type} .= "&outer_part";  #---可做film外层又可做ldi外层
			$list->{$layer}{new_type} .= "&ldiout_part";
			$list->{$layer}{new_type} .= "&chuhuafilm";   #---又是出货film
			$list->{$layer}{new_type} .= "&film_part";         #--又是film文件
			$list->{$layer}{new_type} .= "gangwan_part";      #----又是钢网
			$list->{$layer}{new_type} .= "orig_part";         #--原稿
			$list->{$layer}{new_type} .= "pdf_part";  #--图纸
		}
		if ($list->{$layer}{context} =~ /board/i && $list->{$layer}{layer_type} =~ /mask/i && $list->{$layer}{side} =~ /top|bot/i) {
			$list->{$layer}{new_type} .= ".mask_part";
			$list->{$layer}{new_type} .= "&chuhuafilm";   #---又是出货film
			$list->{$layer}{new_type} .= "&film_part";         #--又是film文件
			$list->{$layer}{new_type} .= "gangwan_part";      #----又是钢网
			$list->{$layer}{new_type} .= "orig_part";         #--原稿
			$list->{$layer}{new_type} .= "pdf_part";  #--图纸
		}
		if ($list->{$layer}{context} =~ /board/i && $list->{$layer}{layer_type} =~ /silk/i && $list->{$layer}{side} =~ /top|bot/i) {
			$list->{$layer}{new_type} .= ".silk_part";
			$list->{$layer}{new_type} .= "&chuhuafilm";   #---又是出货film
			$list->{$layer}{new_type} .= "&film_part";         #--又是film文件
			$list->{$layer}{new_type} .= "gangwan_part";      #----又是钢网
			$list->{$layer}{new_type} .= "pdf_part";  #--图纸
		}
		#else{
		#	$list->{$layer}{new_type} .= "other_part";         #--其它
		#}
	}
}

1;

