#!/usr/bin/perl

=head
     01/29/16 HongBaiQing
=cut

package OutputDrill;

use strict;
use warnings;
use Encode;
use File::Basename;
use File::Copy;
use File::Path qw(make_path);
use utf8;
use Data::Dumper;
#============================

#=======================输出钻带部分 start==================================
#-----------钻孔部分----------



sub add_last_hole{
	my $self = shift;
	my $step = shift;
	my $layer = shift;
	my $action = shift;
	
	if ($action =~ /add/i) {

		if (! exists $self->{lastHoleX}) {
			$self->{lastHoleX} = $self->{SR_xmin}*25.4-5;
			$self->{lastHoleY} = $self->{PROF_ymax}/4*25.4;
		}


		my $temp_lay = "${layer}_$$";
		$self->COM ("flatten_layer,source_layer=$layer,target_layer=$temp_lay");
		$self->work_affected_layer($temp_lay);
		$self->COM("sel_break");
		my $symList = $self->SYMS_HIST_LIST($step,$temp_lay,"mm");
		$self->delete_layer($temp_lay);
			
		my @allHoles = ();
		my @one = ();
		my @two = ();
		my @three = ();
		my @normal = ();
		my @slots = ();
		my @seven = ();
		
		foreach my $key (keys %{$symList}) {
			my $symbol = $symList->{$key}{symbol};
			$symbol  =~ s/r//g;
			if ($symList->{$key}{pad}>0) {
				push @allHoles,[$symbol,"pad"];
			}
			if ($symList->{$key}{line}>0 && $symList->{$key}{symbol} ne "r508") { #---508为字唛
				push @slots,[$symbol,"line"];
			}			
		}



		for my $P (@allHoles) {
			if ($P->[0] =~ /2051/) {
				push @one,[@{$P}];
			}
			elsif ($P->[0] =~ /3175/) {
				push @two,[@{$P}];
			}
			elsif ($P->[0] =~ /503/) {
				push @three,[@{$P}];
			}
			elsif ($P->[0] =~ /508/) {
				push @seven,[@{$P}];
			}
			else{
				push @normal,[@{$P}];
			}
		}
		@one = sort { $a->[0] <=> $b->[0]} @one;
		@two = sort { $a->[0] <=> $b->[0]} @two;
		@three = sort { $a->[0] <=> $b->[0]} @three;						
		@normal = sort { $a->[0] <=> $b->[0]} @normal;
		@slots = sort { $a->[0] <=> $b->[0]} @slots;
		@seven = sort { $a->[0] <=> $b->[0]} @seven;
		@allHoles = (@one,@two,@three,@normal,@slots,@seven);

		$self->work_affected_layer($layer);
		$self->units("mm");
		foreach my $i (0..$#allHoles) {
			my $dis  = 0;
			my $size = $allHoles[$i][0];
			$self->{lastHoleY} += ($size / 2 / 1000);
			$self->COM("cur_atr_reset");
			$self->COM("cur_atr_set,attribute=.string,text=tmptxt");
			$self->COM("cur_atr_set,attribute=.drill_first_last,option=last");
			if ($allHoles[$i][1]=~ /pad/) {
				$self->add_pad($self->{lastHoleX},$self->{lastHoleY},"r".$size,"positive",0,"yes");
			}
			elsif ($allHoles[$i][1]=~ /line/) {
				$self->add_line($self->{lastHoleX},$self->{lastHoleY},$self->{lastHoleX},$self->{lastHoleY},"r".$size,"positive","yes");
			}

			$dis = $size / 2 / 1000 + 0.5;
			$self->{lastHoleY} += $dis;
		}
		$self->units("inch");
		$self->COM("cur_atr_reset");
	}
		

	if ($action =~ /delete/i) {
		$self->work_affected_layer($layer);
		$self->filter_reset;
		$self->filter_set_attribute(".string","tmptxt");
		$self->filter_area_strt();
		if ($self->COM("get_select_count")) {
			$self->sel_delete;
		}
	}
}





sub out_drill{
	my $self = shift;
	my ($type,$step,$layer,$mir,$angle,$xori,$yori,$xscale,$yscale,$outName,$compare,$report,$addLastHole) = @_;


	


	my $drlLayer =  "${layer}_$$";
	my $file = "C:/tmp/$drlLayer";
	$outName = encode('gb2312',$outName);



	#---加尾孔
	if ($addLastHole =~ /add/) {
		$self->add_last_hole($step,$layer,"add");
	}
		

	#$self->COM("ncset_page_open");
	$self->COM("ncset_cur,job=$self->{Job},step=$step,layer=,ncset=");
    $self->COM("ncset_cur,job=$self->{Job},step=$step,layer=$layer,ncset=");
	$self->VOF;
    $self->COM("ncset_delete,name=1");
    $self->VON;
	$self->COM("ncset_create,name=1");
	$self->COM("ncset_cur,job=$self->{Job},step=$step,layer=$layer,ncset=1");
	$self->COM("ncd_set_machine,machine=excellonxd,thickness=0");
	$self->COM("ncset_units,units=mm");
	#$self->COM("ncd_set_params,format=Excellon2,zeroes=trailing,units=mm,tool_units=mm,nf1=3,nf2=3,decimal=no,modal_coords=no,single_sr=yes,sr_zero_set=no,repetitions=sr,incremental=no,optimize=yes,iterations=10,reduction_percent=1,cool_spread=0,break_sr=$break,sort_method=Standard,strip_width=0,xspeed=2540,yspeed=2540,rout_layer=ncd,fixed_tools=yes,tools_assign_mode=increasing_size,comp_short_slot=no");	
	#$self->COM("ncd_auto_all,create_drill=no");
	
	
	$self->COM("ncd_register,angle=$angle,mirror=$mir,xoff=0,yoff=0,version=1,xorigin=$xori,yorigin=$yori,xscale=$xscale,yscale=$yscale,xscale_o=0,yscale_o=0");
	$self->COM("ncd_cre_drill");

	#---有加尾孔 生成一层 ncd-$layer
	my $ncd_layer = "ncd-$layer";
	$self->COM("ncd_cre_layer,stage=1,split=1,layer=$ncd_layer,profile_outline=no,type=drills");

    
	#$self->PAUSE("=====000");

	#--出钻带
	$self->COM("ncd_ncf_export,stage=1,split=1,dir=C:/tmp,name=$drlLayer");
	#$self->COM("ncset_page_close");

	#---删掉刀速与零点 加 MM,LZ  
	$self->delete_speed_origin($file);

    #$self->COM("ncset_delete,name=1");

	if (! -e $file) {
		push @{$self->{error}},"output->${step}->${layer} 失败";
		return "error";
	}


	#---加尾孔
	$self->add_last_hole($step,$layer,"delete");


	#---打散型号孔方便算孔数
	#$self->work_affected_layer($layer);
	#$self->COM("sel_break");


	my $dir = dirname $outName;
	make_path($dir);

	#---读入对比
	if ($compare =~ /compare/) {
		my $outLayer = $drlLayer;
		$self->COM("input_manual_reset");
		$self->COM("input_manual_set,path=$file,job=$self->{Job},step=$step,format=Excellon2,data_type=ascii,units=mm,\
					 coordinates=absolute,zeroes=trailing,nf1=3,nf2=3,decimal=no,separator=nl,tool_units=mm,layer=$outLayer,wheel=,\
					 wheel_template=,nf_comp=0,multiplier=1,signed_coords=no,break_sr=yes,drill_only=no,merge_by_rule=no");
		$self->COM("input_manual,script_path=");

		$self->work_affected_layer($outLayer);
		#--镜像回去
		if ($mir =~ /yes/i) {
			$self->COM("sel_transform,mode=anchor,oper=mirror,duplicate=no,x_anchor=0,
				y_anchor=0,angle=0,x_scale=1,y_scale=1,x_offset=0,y_offset=0");
		}




		#---不是0度旋转
		$angle =   ($angle == 90) ? 270 
				 : ($angle == 180) ? 180 
				: ($angle == 270) ? 90  : 0;	 
		 if ($angle) {
			 $self->COM("sel_transform,mode=anchor,oper=rotate,duplicate=no,x_anchor=0,
				y_anchor=0,angle=$angle,x_scale=1,y_scale=1,x_offset=0,y_offset=0");
		}


		
		$self->COM("register_layers,reference_layer=$ncd_layer,tolerance=2,mirror_allowed=yes,\
					rotation_allowed=no,zero_lines=yes,reg_mode=affected_layers,register_layer=");
	

		my $map = "${layer}_compare";
		$self->COM("compare_layers,layer1=$outLayer,job2=$self->{Job},step2=$step,layer2=$ncd_layer,\
                layer2_ext=,tol=2,area=global,ignore_attr=,map_layer=$map,map_layer_res=200");
		my $diff = $self->{COMANS};


		unless($diff) {   #---一样
			move ($file,$outName) or die "$!";			
			$self->delete_layer($map);
			$self->delete_layer($outLayer);
			$self->delete_layer($ncd_layer);

			#--钻咀表
			$self->make_excel($step,$layer);
		}
		else{
			unlink $file;
			push @{$self->{error}},"output->${step}->${layer} 读入对比不一样";
			#$self->delete_layer($map);
			#$self->delete_layer($outLayer);
			print "output->${step}->${layer} diff-------------------\n";
			return "error";
		}
	}
	else{
		move ($file,$outName) or die "$file copy failed $!";
		#--钻咀表
		$self->make_excel($step,$layer);			
	}

	#$self->PAUSE("=====001");
}




#=============
#---删掉刀速与零点 加 MM,LZ
sub delete_speed_origin{
    my $self = shift;
    my $oldFile = shift;
	my $nemFile = "C:/tmp/file2.$$";

	my @xin =();
    open (FILE_W,">$nemFile") or die" can't open $nemFile, $!";
    open (FILE,"$oldFile")      or die" can't open $oldFile $!";
    while (<FILE>) {
	    chomp;
		if (/M48/) {
			$_ = "$_\n"."MM,LZ";
		}
        if (/(0S300F2159H5000$)/) { 
            $_ =~ s/$1//g;
        }
        if (/(0S300F2159H500$)/) { 
            $_ =~ s/$1//g;
        }
        if (/(S300F2159H5000$)/) { 
            $_ =~ s/$1//g;
        }
        if (/(S300F2159H500$)/) { 
            $_ =~ s/$1//g;
        }

        if (/^M71/) {
            next;
        }


        if (/G93X0Y0/) {
            next;
        }
		if (/^T\d{2}(C\.)/) {
			 $_ =~ s/$1/C0\./g;
		}

		if ($_ =~ /\*/) {     #星号放到最后
			push @xin,$_;
			next;
		}
		if (@xin == 1) {  #---把*号的坐标也放进去
			push @xin,$_;
			next;
		}

        if (/M30/) {
			if (@xin) {
				$_ = "$xin[0]\n$xin[1]\nT00\nM30";
			}
			else{
				$_ = "T00\nM30";
			}
        }

        print FILE_W "$_\n";
    }
    close FILE;
    close FILE_W;
    move ($nemFile,$oldFile) or die "$nemFile copy failed $!"; 
}









#----打散型号孔
sub break_job_num{
	my $self = shift;
	my $flag = 0;
	$self->{breakNum} = 0;
	$self->filter_reset;
	$self->filter_set_feat_types("text");
	$self->COM("adv_filter_set,filter_name=popup,update_popup=yes,str_len=yes,min_str_len=2,max_str_len=20");
	#$self->COM("adv_filter_set,filter_name=popup,update_popup=no,txt_types=string");
	$self->filter_area_strt();
	if ($self->COM("get_select_count")) {
		$self->COM("sel_break");
		$flag = 1;
		$self->filter_reset;
		$self->COM("filter_set,filter_name=popup,update_popup=no,feat_types=line");
		$self->COM("filter_set,filter_name=popup,update_popup=no,include_syms=r19.291");
		$self->filter_area_strt();
		if ($self->COM("get_select_count")) {
			$self->COM("sel_line2pad");
			$flag = 2;
		}		
	}
	$self->filter_reset;
	$self->{breakNum} = $flag;
	return  $flag;
}





#=======================输出钻带部分 end==================================







1;

