#!/usr/bin/perl

=head
     01/29/16 HongBaiQing
=cut

package OutputExcel;

use strict;
use warnings;
use Encode;
use File::Copy;
use File::Path qw(make_path);
use utf8;
use Win32::OLE;
use Win32::OLE qw(in with);
use Win32::OLE::Const 'Microsoft Excel';
use Data::Dumper;

#=====================================================


#=======================================================================

sub make_excel{
	my $self = shift;
	my $pnlStep = shift;
	my $layer = shift;


	if ($pnlStep !~ /pnl/) {
		return;
	}

	if ($layer =~ /via/) {
		return;
	}

	#--t序号对应的钻咀，shape 总孔数 
	my $rep = $self->get_drill_rep_data;



	#---获取钻孔信息
	my $ha = $self->get_holes_info($pnlStep,$layer);


	#--整理数据
	$self->make_data($pnlStep,$layer,$ha);


	$self->output_data($rep,$ha,$pnlStep,$layer);
}





sub output_data{
	my $self = shift;
	my $rep = shift;
	my $ha = shift;
	my $pnlStep = shift;
	my $layer = shift;

	my @all = ();
	foreach my $infodz (keys %{$ha}) {
		foreach my $one (@{$ha->{$infodz}{info}}) {	
			foreach my $tnum (keys %{$rep}) {
				#--钻刀相同 且 shape相同 -同是孔或是slot
				if ($infodz == $rep->{$tnum}{dz} && $one->[6] eq $rep->{$tnum}{shape} ) { 
					my $T = ($tnum<10) ? "T0$tnum" : "T$tnum";
					if ($infodz =~ /0.508/) {
						$rep->{$tnum}{count} = $ha->{$infodz}{info}[0][5];
					}
					push @{$one},$tnum,$T,$rep->{$tnum}{count},$infodz;
					push @all, [@{$one}];

				}
			}

		}
	}



#	my @all = ();
#	foreach my $infodz (keys %{$ha}) {
#		foreach my $tnum (keys %{$rep}) {
#			if ($infodz == $rep->{$tnum}{dz}) { #--钻刀相同
#				foreach my $one (@{$ha->{$infodz}{info}}) {				
#					if ($one->[6] eq $rep->{$tnum}{shape}) {  #--同是孔或是slot
#						my $T = ($tnum<10) ? "T0$tnum" : "T$tnum";
#
#						if ($infodz =~ /0.508/) {
#							$rep->{$tnum}{count} = $ha->{$infodz}{info}[0][5];
#						}
#
#						#push @{$one},$tnum,,$T,$rep->{$tnum}{count},$infodz;
#						push @{$one},$tnum,$T,$rep->{$tnum}{count},$infodz;
#						push @all, [@{$one}];
#					}
#				}
#
#			}
#		}
#	}
	
	#---0     1      2     3   4        5          6       7    8         9         10   11        12     13      14     15
	# 成品  PTH/NPT +TOL -TOL slot长度 单只个数 hole/slot step 条孔钻数 条孔尺寸   序号 T序号   整板总数  钻刀    备注  合并公差
	@all = sort {$a->[10]<=>$b->[10]} @all;
	#print Dumper $ha;
	#print Dumper \@all;
	#print Dumper $rep;
	#exit;





	foreach my $p (@all) {
		
		$p->[14]  = '';
		if ($p->[13] =~ /3.175/) {
			$p->[14] = encode('gb2312',"靶孔");
		}
		if ($p->[13] =~ /3.201/) {
			$p->[14] = encode('gb2312',"工具孔");
		}
		if ($p->[13] =~ /0.503/) {
			$p->[14] = encode('gb2312',"测试孔");
		}
		if ($p->[13] =~ /1.15/) {
			$p->[14] = encode('gb2312',"含切片孔");
		}
		if ($p->[13] =~ /3.15/) {
			$p->[14] = encode('gb2312',"含阻焊对位孔");
		}
		if ($p->[13] =~ /3.176/) {
			$p->[14] = encode('gb2312',"含vcut挂孔");
		}
		if ($p->[13] =~ /0.508/ ) {
			$p->[14] = encode('gb2312',"料号孔");
		}
		if ($p->[4] > 0) {
			#$p->[0] = $p->[9];
			my $tmp = $p->[0]+$p->[4]/1000;
		     $tmp = sprintf("%0.3f",$tmp);
			$p->[0] = "$p->[0]x$tmp";

			#---条孔是否存在板边尾孔
			my $have = 0;
			my $infodz = $p->[13];
			foreach my $one (@{$ha->{$infodz}{info}}) {	
				if ($one->[7] =~ /pnl/) {
					$have = 1;
				}
			}
			if ($have==1) {  #--条孔有板边尾孔
				$p->[12] = ($p->[12]-1)*$p->[8]+1;    #---减1是减掉出刀孔
			}
			else{ #--条孔没有板边尾孔
				$p->[12] = $p->[12]*$p->[8];    
			}
	
			$p->[14] = encode('gb2312',"槽孔$p->[8]");
		}

		#--公差
		$p->[15]  = '';
		if ($p->[2] ne "" && $p->[3] ne "" ) {
			my $tolz = $p->[2]/1000;
			my $tolf = $p->[3]/1000;
			$p->[15] = "\+$tolz\/\-$tolf";
		}
	}
	
	#---所有孔总数
	my $total = 0;
	foreach my $tnum (keys %{$rep}) {
		$total += $rep->{$tnum}{count};
	}


#	#--合并条孔
#	my $n = 0;
#	while ($n<=$#all) {
#		if ($all[$n][4]>0) {
#			my $m=$n+1;
#			while ($m<=$#all) {
#				if ($all[$m][4]>0) {
#					my ($fzn,$longn) = (split 'x',$all[$n][0]);
#					my ($fzm,$longm) = (split 'x',$all[$m][0]);
#					if ($fzn eq $fzm && $all[$n][13] eq $all[$m][13] && $all[$n][1] eq $all[$m][1] ) {
#						splice @all,$m,1;
#						$all[$n][0] = $all[$n][0].'/'.$longm;
#						$m--;
#					}
#				}
#				$m++;
#			}
#		}
#		$n++;
#	}





	#---0     1      2     3   4        5          6       7    8         9         10   11        12     13      14     15
	# 成品  PTH/NPT +TOL -TOL slot长度 单只个数 hole/slot step 条孔钻数 条孔尺寸   序号 T序号   整板总数  钻刀    备注  合并公差


	#print Dumper \@all;
	#exit;




	#--Excel 模板文件
	#my $CurScriptPath = $FindBin::Bin;
	my $CurScriptPath =  $self->{script_path};


	my $excelFileFrom    = encode('gb2312',"$CurScriptPath/drl钻孔表.xls");

	my $outPath  = encode('gb2312',"$self->{dialog}{OutputPath}/cnc/钻咀表");
	make_path($outPath);
	#--输出的 Excel 文件
	my $excelFileTarget  = encode('gb2312',"/$self->{Job}_$layer.xls");	
	$excelFileTarget  = $outPath.$excelFileTarget;



	#--从 Excel 模板文件 复制到 输出的 Excel 文件
	if ( -e $excelFileTarget) {
		unlink $excelFileTarget;
	}
	copy($excelFileFrom,$excelFileTarget) or die $excelFileFrom." copy failed $!"; 
		
	#--打开 Excel API
    my $Excel = $self->ExcelGetObject(0);
	$Excel->{DisplayAlerts} = 'False';
	$Excel->{ScreenUpdating} = 'False';

	#--打开 Excel 文件
	my $Book  = $self->ExcelWorkOpen($Excel,$excelFileTarget);




	








	#--打开 sheet
	my $selSheet = $layer;
							
	my $sheetName = encode('gb2312',$selSheet);
	my $SheetAct = $Book->Activesheet;
	$SheetAct->{Name} = $sheetName;
	my $Sheet = $self->ExcelWorkSheet($Book,$sheetName);



	#---0     1      2     3   4        5          6       7    8         9         10   11        12     13      14     15
	# 成品  PTH/NPT +TOL -TOL slot长度 单只个数 hole/slot step 条孔钻数 条孔尺寸   序号 T序号   整板总数  钻刀    备注  合并公差

    my $toolSheetLineNum = 2;#--Execle 表格行殊，从第 2 行开始加
	foreach my $line (@all) {
		my $tnum = $line->[11];
		my $fz = $line->[0];
		my $dz = $line->[13];
		my $type = $line->[1];
		my $count = $line->[12];
		my $tol =  $line->[15];
		my $remark = $line->[14];


		$self->ExcelSetCellValue($Sheet,$toolSheetLineNum,1,$tnum);        #--T序号
		$self->ExcelSetCellValue($Sheet,$toolSheetLineNum,3,$fz);        #--成品
		$self->ExcelSetCellValue($Sheet,$toolSheetLineNum,4,$type);        #--PTH NPTH VIA
		$self->ExcelSetCellValue($Sheet,$toolSheetLineNum,5,$tol);        #--公差
		$self->ExcelSetCellValue($Sheet,$toolSheetLineNum,6,$dz);        #--钻刀
		$self->ExcelSetCellValue($Sheet,$toolSheetLineNum,11,$count);        #--数量
		$self->ExcelSetCellValue($Sheet,$toolSheetLineNum,16,$remark);        #--备注

		$toolSheetLineNum++;	
	}

	my $txt = encode('gb2312',"合计");
	$self->ExcelSetCellValue($Sheet,$toolSheetLineNum,11,$total);        #--总数
	$self->ExcelSetCellValue($Sheet,$toolSheetLineNum,16,$txt);        #--总数


	#$Excel->{DisplayAlerts} = 'True';  
	$Excel->{DisplayAlerts} = 'False';
	$self->ExcelObjectSave($Book);
	$self->ExcelObjectClose($Book);



}



sub make_data{
	my $self = shift;
	my $pnlStep = shift;
	my $layer = shift;
	my $ha = shift;




	my @all = ();
	#---0     1      2     3   4        5          6       7    8          9
	# 成品  PTH/NPT +TOL -TOL slot长度 单只个数 hole/slot step 条孔钻数  条孔尺寸
	#--只有板边孔
	foreach my $dz (keys %{$ha}) {
		if (@{$ha->{$dz}{info}}==1 && $ha->{$dz}{info}[0][7] =~ /$pnlStep/) {
			$ha->{$dz}{info}[0][0] = ""; 
			$ha->{$dz}{info}[0][1] = ""; 
			$ha->{$dz}{info}[0][2] = "";
			$ha->{$dz}{info}[0][3] = "";			
		}

		my $pnl =  $ha->{$dz}{info}[0][7];
		if (!grep /^$pnl/,@all) {
			push @all,$pnl;
		}
	}

	#---删掉尾孔
	if (@all>1) {
		foreach my $dz (keys %{$ha}) {
			my @tmp = ();
			foreach my $one (@{$ha->{$dz}{info}}) {
				if ($one->[7] =~ /$pnlStep/ && $one->[5] ==1) {
					next;
				}
				push @tmp,[@{$one}];
			}
			@{$ha->{$dz}{info}} =@tmp;
		}
	}




	#---合并
	foreach my $dz (keys %{$ha}) {
		if (@{$ha->{$dz}{info}}>1){
			for my $i(0..$#{$ha->{$dz}{info}}) {
				my ($fz,$type,$tolz,$tolf,$long,$count,$shape,$step) = @{$ha->{$dz}{info}[$i]};
				for my $j($i+1..$#{$ha->{$dz}{info}}) {
					my ($fz_n,$type_n,$tolz_n,$tolf_n,$long_n,$count_n,$shape_n,$step_n) = @{$ha->{$dz}{info}[$j]};
					if ($fz eq $fz_n && $type eq $type_n && $tolz eq $tolz_n && $tolf eq $tolf_n && $long eq $long_n) {
						$ha->{$dz}{info}[$i] = ["null"];
						last;
					}
				}

				#--板边 与单元同时都有
				if ($fz == 0  && $tolz == 0  && $tolf  == 0  && $long == 0  && $step=~ /$pnlStep/ && $dz !~ /0.508/) {
					$ha->{$dz}{info}[$i] = ["null"];
					last;
				}
			}

			my @tmp = ();
			foreach my $P (@{$ha->{$dz}{info}}) {
				if (! grep /null/,@{$P} ) {
					push @tmp,[@{$P}]
				}
			}
			@{$ha->{$dz}{info}} = @tmp;
		}
	}



	#--型号孔  只保留一个
	my $size = '0.508';
	if (exists $ha->{$size}) {
		$ha->{$size}{info}[0][0] = '';
		$ha->{$size}{info}[0][1] = '';
		$ha->{$size}{info}[0][2] = '';
		$ha->{$size}{info}[0][3] = '';
		for my $i(1..$#{$ha->{$size}{info}}) {
			$ha->{$size}{info}[0][5] = $ha->{$size}{info}[0][5]+$ha->{$size}{info}[$i][5];
			$ha->{$size}{info}[$i] = ["null"];
		}
		@{$ha->{$size}{info}} = ([@{$ha->{$size}{info}[0]}]);
	}



	#---条孔
	foreach my $dz (keys %{$ha}) {
		for my $i(0..$#{$ha->{$dz}{info}}) {
			$ha->{$dz}{info}[$i][8] = "";
			$ha->{$dz}{info}[$i][9] = "";
			if ($ha->{$dz}{info}[$i][4]>0) {
				my $long = $ha->{$dz}{info}[$i][4]/1000;
				$ha->{$dz}{info}[$i][8] = $self->calc_hole_hits($long,$dz);
				my $maxLong = sprintf("%0.3f",$long+$dz);
				$ha->{$dz}{info}[$i][9] = $dz.'x'.$maxLong;
			}			
		}
	}
}



#---获取钻孔信息
sub get_holes_info{
	my $self = shift;
	my $pnlStep = shift;
	my $layer = shift;
	#---取各step的孔信息
	my $allstepsIn   =  $self->get_all_step_repeat($pnlStep);
	my %have;
	my $ha = {};
	foreach my $step (@{$allstepsIn},$pnlStep) {
		if (! exists $have{$step}) {
			$have{$step}++;
			my $list = $self->info_drl_tool($step,$layer,"mm");
			foreach my $num  (keys %{$list}) {
				my $dz = sprintf ("%0.3f",$list->{$num}{drill_size}/1000);
				my $fz = sprintf ("%0.3f",$list->{$num}{finish_size}/1000);
				my $tolz = $list->{$num}{max_tol};
				my $tolf = $list->{$num}{min_tol};
				my $shape = $list->{$num}{shape};
				my $type = $list->{$num}{type};
				$type = ($type =~ /non_plate/) ? "N" : "Y";
				my $count = $list->{$num}{count};
				my $long = $list->{$num}{slot_len};

				if ($step ne $pnlStep) {
					if ($tolz ==0 && $tolf==0) {
						($tolz,$tolf) = ($type =~ /y/i) ? (75,75) : (50,50);
					}
					if ($fz==0) {
						$fz = $dz;
					}
				}
				push @{$ha->{$dz}{info}},[$fz,$type,$tolz,$tolf,$long,$count,$shape,$step];
			}
		}
	}
	return $ha;
}




sub get_drill_rep_data{
	my $self = shift;
	my $file = "C:/tmp/drill_rep";
	my $ha = {};
	if (! -e $file) {
		return $ha;
	}
	
	
	my %ha;
	my $lines = $self->ReadFile($file);
	foreach my $line (@{$lines}) {
		if ($line =~ /drlSizeMM==(\S+);ncCOUNT==(\S+);ncDESIGNATOR.*;ncSHAPE==(\S+);ncSIZE.*order==(\S+);/) {
			my ($dz,$count,$shape,$tnum) = ($1,$2,$3,$4);
			$shape = ($shape =~ /text/i) ? "hole" : $shape;
			$ha{$tnum}{shape} = $shape;
			$ha{$tnum}{dz} = sprintf("%0.3f",$dz/1000);
			if (exists $ha{$tnum}{count}) {
				$ha{$tnum}{count} = $ha{$tnum}{count}+$count;
			}
			else{
				$ha{$tnum}{count} =  $count;
			}
		}
	}	
	return \%ha;	
}















#=========================================================


1;

