=head
	包    名: OutputMainLianyi
	编码人员: 洪柏青/ccs
	功    能: 单元编辑功能--edit模块
	编码时间: 2021-09-15	
=cut

package OutputGerberMain;

use Encode;
use File::Copy;
use File::Path qw(make_path remove_tree);
use strict;
use warnings;
use utf8;
use Data::Dumper;
use Tk;
use Storable;
use lib "$FindBin::Bin";
use File::Basename;
use Win32::API;
use Time::localtime;






sub OutputGerberMain{
	my $self        = shift;

	$self->COM("config_edit,name=gen_line_skip_post_hooks,value=2,mode=user");
    $self->COM("config_edit,name=gen_line_skip_pre_hooks,value=2,mode=user");

	my $oldStep = (exists $self->{Step})  ? $self->{Step} : "";


	#--检查阴阳拼板的要更新后，释放关系
	$self->check_flip_step("release");


	#---读入所有层
	$self->{matrix}    = $self->info_matrix();	


	#----删掉旧文件夹
	$self->delete_old_folder();


	foreach my $part (@{$self->{all_part}}) {
		if ($self->{dialog}{$part}{sel}) {
			my $sub = "output_$part";
			print "output $sub ---------------\n";
			$self->$sub($part);
			#--字符打印机 ok
			#--钻孔  ok
			#---内层 外层   ok
			#--阻焊     ok
			#--字符
			
			#--铣边
			#--钻孔
		}
	}


	#--检查阴阳拼板的, 恢复关系
	$self->check_flip_step("restore");

	$self->COM("config_edit,name=gen_line_skip_post_hooks,value=1,mode=user");
    $self->COM("config_edit,name=gen_line_skip_pre_hooks,value=1,mode=user");

	#if ($oldStep ne "") {
	#	$self->open_step($oldStep,"inch","no");
	#}

	if ($self->{hostname} ne 'TECH62'){   #--自己电脑不关
		$self->close_job($self->{Job});
		$self->VOF;
		$self->COM("check_inout,mode=in,type=job,job=$self->{Job}");
		$self->VON;
	}
}


sub output_pdf{
	my $self = shift;
	my $part = shift;

	my $list = $self->{dialog}{$part}{selLayers};
	my $step = $self->{dialog}{$part}{step};
	$self->open_step($step,"inch","yes");
	$self->get_step_profile($step);

	
	my $outNamePdf = "null";
	foreach my $layer (sort{$self->{matrix}{$a}{row}<=>$self->{matrix}{$b}{row}} keys %{$list} ) {
		if ( $list->{$layer}{sel} != 1) {next;}


		$outNamePdf =  ($layer =~ /gdd/) ?     "$self->{dialog}{OutputPath}/mi/$self->{Job}_分孔图.pdf" 
			          :($layer =~ /vcutmap/) ? "$self->{dialog}{OutputPath}/mi/$self->{Job}_vcut图.pdf" 
			          :($layer =~ /biaozhu/) ? "$self->{dialog}{OutputPath}/mi/$self->{Job}_外形尺寸图.pdf" 
			                             : "$self->{dialog}{OutputPath}/mi/$self->{Job}_${layer}.pdf" ;


		my $outNameDxf = ($layer =~ /gdd/) ?      "$self->{dialog}{OutputPath}/mi/$self->{Job}_分孔图.dxf" 
			             :($layer =~ /vcutmap/) ? "$self->{dialog}{OutputPath}/mi/$self->{Job}_vcut图.dxf"   
			             :($layer =~/biaozhu/) ? "$self->{dialog}{OutputPath}/mi/$self->{Job}_外形尺寸图.dxf" 
			                             : "$self->{dialog}{OutputPath}/mi/$self->{Job}_${layer}.dxf" ;




		$outNamePdf  = encode('gb2312',$outNamePdf);
		$outNameDxf  = encode('gb2312',$outNameDxf);

		my $dir = dirname $outNamePdf;
		make_path($dir);

		#----有换step的
		my $changeStep = $self->{dialog}{pdf}{selLayers}{$layer}{changeStep};
		if ($changeStep ne "") {
			$step = $changeStep;
			$self->open_step($step,"inch","yes");
			$self->get_step_profile($step);
		}


		my $title = $self->{Job};

		#---这段会加上一个大方框
#		$self->COM("output_layer_reset");
#		$self->COM("output_layer_set,layer=$layer,angle=0,mirror=no,x_scale=1,y_scale=1,\
#						comp=0,polarity=positive,setupfile=,setupfiletmp=,line_units=inch,gscl_file=");
#		$self->COM("output,job=$self->{Job},step=$step,format=PostScript,\
#						dir_path=C:/tmp,prefix=,suffix=.ps,break_sr=yes,break_symbols=yes,\
#						break_arc=no,scale_mode=all,surface_mode=contour,min_brush=1,\
#						x_anchor=0,y_anchor=0,x_offset=0,y_offset=0,line_units=inch,override_online=yes,\
#						params_opt=yes,orientation=automatic,title_opt=fix+auto,title=$title,\
#						size_mode=A4,width=0,height=0,scale=0,output_files=multiple");	


		#---这段不会加上一个大方框
		my $file = "C:/tmp/".$layer.'.ps';
		$self->COM("print,title=,layer_name=$layer,mirrored_layers=,draw_profile=no,drawing_per_layer=yes,label_layers=no,\
			   dest=ps_file,num_copies=1,dest_fname=$file,paper_size=A4,scale_to=0,nx=1,ny=1,orient=none,paper_orient=portrait,\
				   paper_width=0,paper_height=0,auto_tray=no,top_margin=0,bottom_margin=0,left_margin=0,right_margin=0,x_spacing=0,\
				y_spacing=0,color1=990000,color2=9900,color3=99,color4=990099,color5=999900,color6=9999,color7=0");



		#system("$gs_converter_dir -dSAFER -q -dNOPAUSE -dBATCH -sDEVICE=pdfwrite -sPAPERSIZE=A4 -sOutputFile=$outName -dSAFER -c .setpdfwrite -f @psfilelist");
		my $gs_converter_dir  = "C:/gs/gs9.06/bin/gswin32.exe";

		system("$gs_converter_dir -dSAFER -q -dNOPAUSE -dBATCH -sDEVICE=pdfwrite -sPAPERSIZE=A4 -sOutputFile=$outNamePdf -dSAFER -c .setpdfwrite -f $file");
		unlink $file;


		#---输出dxf
		$self->COM("output_layer_reset");
		$self->COM("output_layer_set,layer=$layer,angle=0,mirror=no,x_scale=1,y_scale=1,\
								comp=0,polarity=positive,setupfile=,setupfiletmp=,line_units=mm,\
								gscl_file=,step_scale=no");
		$self->COM("output,job=$self->{Job},step=$step,format=DXF,dir_path=C:/tmp,\
								prefix=$self->{Job}.,suffix=.dxf,break_sr=yes,break_symbols=yes,break_arc=no,\
								scale_mode=all,surface_mode=contour,min_brush=1,units=mm,x_anchor=0,\
								y_anchor=0,x_offset=0,y_offset=0,line_units=inch,override_online=yes,\
								pads_2circles=yes,draft=all,contour_to_hatch=yes,pad_outline=yes,\
								output_files=single,file_ver=old");
		move ("c:/tmp/$self->{Job}.$layer.dxf",$outNameDxf) or die "$!";

		#---换回默认的step
		if ($changeStep ne "") {
			$self->editor_page_close;
			$step = $self->{dialog}{$part}{step};
			$self->open_step($step,"inch","yes");
			$self->get_step_profile($step);
		}
	}



	$self->clear_layers();
	$self->editor_page_close;
	if ( $outNamePdf !~ /null/) {
		print "----------$part end---------\n";
	}
}









sub output_guanwan{
	my $self = shift;
	my $part = shift;
	#print Dumper $self->{dialog}{$part};

	my $list = $self->{dialog}{$part}{selLayers};
	my $step = $self->{dialog}{$part}{step};
	$self->open_step($step,"inch","yes");
	$self->get_step_profile($step);
	
	#---获取客代码
	my $kedama  = $self->{jobUserInfo}{'客户型号'};




	my $outName = "null";
	foreach my $layer (sort{$self->{matrix}{$a}{row}<=>$self->{matrix}{$b}{row}} keys %{$list} ) {
		if ( $list->{$layer}{sel} != 1) {next;}

		my $xscale = 1;
		my $yscale = 1;
		my $angle =  0;
		my $mir =    "no";
		my ($nf1,$nf2,$wheel,$compare) = (2,6,"","null");
		my ($report,$reread,$pfix,$sfix) = ("null","null","null","null");


		$outName = "$self->{dialog}{OutputPath}/钢网文件和生产文件${kedama}/${layer}.gbr";
		$self->out_Gerber_layer($part,$step,$layer,$outName,$xscale,$yscale,$nf1,$nf2,$mir,$angle,$wheel,$compare,$report,$reread,$pfix,$sfix);
	}


	$self->clear_layers();
	$self->editor_page_close;
	if ($outName !~ /null/) {;
		print "----------$part end---------\n";
	}
}




sub output_orig{
	my $self = shift;
	my $part = shift;
	#print Dumper $self->{dialog}{$part};







	my $list = $self->{dialog}{$part}{selLayers};
	my $step = $self->{dialog}{$part}{step};
	$self->open_step($step,"inch","yes");
	$self->get_step_profile($step);

	my $outName = "null";
	foreach my $layer (sort{$self->{matrix}{$a}{row}<=>$self->{matrix}{$b}{row}} keys %{$list} ) {
		if ( $list->{$layer}{sel} != 1) {next;}

		my $xscale = 1;
		my $yscale = 1;
		my $angle =  0;
		my $mir =    "no";
		my ($nf1,$nf2,$wheel,$compare) = (2,6,"","null");
		my ($report,$reread,$pfix,$sfix) = ("null","null","null","null");
		$outName = "$self->{dialog}{OutputPath}/orig_film/$self->{Job}.$layer";				
		$self->out_Gerber_layer($part,$step,$layer,$outName,$xscale,$yscale,$nf1,$nf2,$mir,$angle,$wheel,$compare,$report,$reread,$pfix,$sfix);
	}


	$self->clear_layers();
	$self->editor_page_close;
	if ($outName !~ /null/) {;
		print "----------$part end---------\n";
	}
}

  

#---输出CNC资料-----------------
sub output_drl{
	my $self = shift;
	my $part = shift;
	#print Dumper $self->{dialog}{$part};






	my $list = $self->{dialog}{$part}{selLayers};
	my $step = $self->{dialog}{$part}{step};
	$self->open_step($step,"inch","yes");
	$self->get_step_profile($step);

	my $outName = "null";
	foreach my $layer (sort{$self->{matrix}{$a}{row}<=>$self->{matrix}{$b}{row}} keys %{$list} ) {
		if ( $list->{$layer}{sel} != 1) {next;}

		if ($self->{matrix}{$layer}{layer_type} =~ /drill/i) {   #层名如drl mao
			
			#----检查是否有大小一样的重叠孔
			$self->check_drill_same_positon($step,$layer);


			#---参数设置---------
			my $xscale = $self->change_ls_format($list->{$layer}{xscale});
			my $yscale = $self->change_ls_format($list->{$layer}{yscale}); #---变成万分之几的数字形式


			my $angle =  0;
			my $mir =    $list->{$layer}{mir};
			my ($xori,$yori) = (0,0);		
			my $compare = "compare";  #compare|null"
			#my $addLastHole = "add";  #add|null"
			my $addLastHole = ($layer =~ /^drl/) ? "add" : "null";
			my $report = "null"; #null|report"
			$outName =  "$self->{dialog}{OutputPath}/cnc/$self->{Job}.$layer";
			if ($layer =~ /jk/) {#--检孔
				$outName =  "$self->{dialog}{OutputPath}/jk/$self->{Job}.$layer";
			}
			#--$self->PAUSE("STAT ====step:$step,layer:$layer,outName:$outName");
			$self->out_drill($part,$step,$layer,$mir,$angle,$xori,$yori,$xscale,$yscale,$outName,$compare,$report,$addLastHole);

			#---生成上传erp的文档
			if ($step =~ /pnl/) {
				$self->make_drill_report($step,$layer,$outName);
			}
			#---$self->PAUSE("====step:$step,layer:$layer,outName:$outName");

		}
		elsif ($layer =~ /^dxf\d/) {#---铣边				
			#---参数
			my $xscale = $self->change_ls_format($list->{$layer}{xscale});
			my $yscale = $self->change_ls_format($list->{$layer}{yscale}); #---变成万分之几的数字形式
			my $angle =  0;
			my $mir =    $list->{$layer}{mir};
			my ($xori,$yori) = (0,0);
			my $compare = "null";
			$outName =  "$self->{dialog}{OutputPath}/cnc/$self->{Job}-${layer}.rou";
			$self->out_rout($step,$outName,$step,$layer,$mir,$angle,$xscale,$yscale,$outName,$compare);
		}
		elsif ($layer =~ /^rkst$|^rksb$/) {#---铣边				
			#---参数
			my $xscale = $self->change_ls_format($list->{$layer}{xscale});
			my $yscale = $self->change_ls_format($list->{$layer}{yscale}); #---变成万分之几的数字形式
			my $angle =  0;
			my $mir =    $list->{$layer}{mir};
			my ($xori,$yori) = (0,0);
			my $compare = "null";
			$outName =  "$self->{dialog}{OutputPath}/cnc/$self->{Job}.$layer";
			$self->out_rout($step,$outName,$step,$layer,$mir,$angle,$xscale,$yscale,$outName,$compare);
		}

		elsif ($layer =~ /^map$/){  #--map
			my $xscale = $self->change_ls_format($list->{$layer}{xscale});
			my $yscale = $self->change_ls_format($list->{$layer}{yscale}); #---变成万分之几的数字形式



			my $angle =  0;
			my $mir =    "no";
			my ($nf1,$nf2,$wheel,$compare) = (2,6,"","null");
			my ($report,$reread,$pfix,$sfix) = ("null","null","null","null");

			my $xyScal = ($xscale ==1 && $yscale == 1) ? "" : "\(X=${xscale}Y=${yscale}\)";
			$outName = "$self->{dialog}{OutputPath}/OK/$self->{Job}${xyScal}.${layer}";
			$self->out_Gerber_layer($part,$step,$layer,$outName,$xscale,$yscale,$nf1,$nf2,$mir,$angle,$wheel,$compare,$report,$reread,$pfix,$sfix);
		}
		else{  #--外形层gko  vcut
			my $xscale = $self->change_ls_format($list->{$layer}{xscale});
			my $yscale = $self->change_ls_format($list->{$layer}{yscale}); #---变成万分之几的数字形式
			my $angle =  0;
			my $mir =    "no";
			my ($nf1,$nf2,$wheel,$compare) = (2,6,"","null");
			my ($report,$reread,$pfix,$sfix) = ("null","null","null","null");

			#my $xyScal = ($xscale ==1 && $yscale == 1) ? "" : "\(X=${xscale}Y=${yscale}\)";
			my $xyScal = "";
			$outName = "$self->{dialog}{OutputPath}/cnc/$self->{Job}${xyScal}.${layer}";
			$self->out_Gerber_layer($part,$step,$layer,$outName,$xscale,$yscale,$nf1,$nf2,$mir,$angle,$wheel,$compare,$report,$reread,$pfix,$sfix);
		}	
	}


	$self->clear_layers();
	$self->editor_page_close;
	if ($outName !~ /null/) {;
		print "----------output_drl end---------\n";
	}
}





sub output_silk{
	my $self = shift;
	my $part = shift;
	#print Dumper $self->{dialog}{$part};





	my $list = $self->{dialog}{$part}{selLayers};
	my $step = $self->{dialog}{$part}{step};
	$self->open_step($step,"inch","yes");
	$self->get_step_profile($step);



	my $outName = "null";
	foreach my $layer (sort{$self->{matrix}{$a}{row}<=>$self->{matrix}{$b}{row}} keys %{$list} ) {
		if ( $list->{$layer}{sel} != 1) {next;}

		#---参数设置---------
		my $xscale = $self->change_ls_format($list->{$layer}{xscale});
		my $yscale = $self->change_ls_format($list->{$layer}{yscale}); #---变成万分之几的数字形式
		my $angle =  0;
		my $mir =    "no";
		my ($nf1,$nf2,$wheel,$compare) = (2,6,"","null");
		my ($report,$reread,$pfix,$sfix) = ("null","null","null","null");

		my $xyScal = ($xscale ==1 && $yscale == 1) ? "" : "\(X=${xscale}Y=${yscale}\)";
		$outName = "$self->{dialog}{OutputPath}/OK/$self->{Job}${xyScal}.${layer}";

		$self->out_Gerber_layer($part,$step,$layer,$outName,$xscale,$yscale,$nf1,$nf2,$mir,$angle,$wheel,$compare,$report,$reread,$pfix,$sfix);
	}

	$self->clear_layers();
	$self->editor_page_close;
	if ($outName !~ /null/) {;
		$self->write_zf_file; #---写字符的信息
		print "----------output_silk end---------\n";
	}
}



#=========================================
sub output_mask{
	my $self = shift;
	my $part = shift;
	print Dumper $self->{dialog}{$part};
	my $list = $self->{dialog}{$part}{selLayers};
	my $step = $self->{dialog}{$part}{step};
	$self->open_step($step,"inch","yes");
	$self->get_step_profile($step);

	my $outName = "null";
	foreach my $layer (sort{$self->{matrix}{$a}{row}<=>$self->{matrix}{$b}{row}} keys %{$list} ) {
		if ( $list->{$layer}{sel} != 1) {next;}

		#---替换ccd symbol
		$self->re_symble_ccd($layer);

		#---参数设置---------
		my $xscale = $self->change_ls_format($list->{$layer}{xscale});
		my $yscale = $self->change_ls_format($list->{$layer}{yscale}); #---变成万分之几的数字形式
		my $angle =  0;
		my $mir =    "no";
		my ($nf1,$nf2,$wheel,$compare) = (2,6,"","null");
		my ($report,$reread,$pfix,$sfix) = ("null","null","null","null");

		my $xyScal = ($xscale ==1 && $yscale == 1) ? "" : "\(X=${xscale}Y=${yscale}\)";
		$outName = "$self->{dialog}{OutputPath}/OK/$self->{Job}${xyScal}-ccd.${layer}";
		$self->out_Gerber_layer($part,$step,$layer,$outName,$xscale,$yscale,$nf1,$nf2,$mir,$angle,$wheel,$compare,$report,$reread,$pfix,$sfix);
	}

	$self->clear_layers();
	$self->editor_page_close;
	if ($outName !~ /null/) {
		#$self->write_zh_file;  #---写阻焊信息  信丰厂不写这样
		print "----------output_mask end---------\n";
	}
}

sub re_symble_ccd{
	my $self = shift;
	my $layer = shift;
	$self->affected_one_layer($layer); 
	$self->filter_reset;
	$self->filter_set_include_syms("qd_ss_ccd");
	$self->filter_area_strt();
	if ($self->COM("get_select_count") == 0) {
		my $sigLayer = ($layer =~ /ts/) ? "tl" : "bl";
		$self->affected_one_layer($sigLayer); 
		$self->filter_reset;
		$self->filter_set_include_syms("qd_ss_ccd");
		$self->filter_area_strt();
		if ($self->COM("get_select_count")) {
			$self->sel_copy_other($layer,"no",0);
			$self->VOF;
			$self->COM("check_inout,mode=out,type=job,job=$self->{Job}");
			$self->VON;
			$self->COM("save_job,job=$self->{Job},override=yes");
		}
	}

	$self->filter_reset;
	$self->sel_clear_feat;
	$self->clear_layers; 		
}





#---写阻焊信息
sub write_zh_file{
	my $self = shift;
	my $dir = "$self->{dialog}{OutputPath}/tgz";
	$dir = encode('gb2312',$dir);
	make_path($dir);
	

	my $B_THK = $self->{jobUserInfo}{'板厚'};
	my $sizeL =  $self->{jobUserInfo}{'板长'};
	my $sizeW =  $self->{jobUserInfo}{'板宽'};



	my $zhTxt = "";
	my $fileZH = encode('gb2312',"/$self->{Job}_ZH.txt");
	$fileZH = $dir.$fileZH;
	my $maskType = $self->{jobUserInfo}{'阻焊油墨型号'};
	my $daihao = $maskType =~ /KSM-S6189\s+GL39/i ? "A-1"
				: $maskType =~ /KSM-S6189\s+GM62/i ? "A-2"
				: $maskType =~ /KSM-S6189\s+EG03H/i ? "A-3"
				: $maskType =~ /KSM-S6189\s+GL27/i ? "A-4"
				: $maskType =~ /KSM-S6189\s+BL04/i ? "A-5"
				: $maskType =~ /KSM-S6189\s+EBL1/i ? "A-6"
				: $maskType =~ /KSM-S6189\s+BLM1/i ? "A-7"
				: $maskType =~ /KSM-S6189\s+R04/i ? "A-8"
				: $maskType =~ /KSM-S6189\s+EB01/ ? "A-9"

				: $maskType =~ /PSR-4000\s+SN10/i ? "B-1"
				: $maskType =~ /PSR-4000\s+G23K/i ? "B-2"
				: $maskType =~ /PSR-9000\s+FLX501/i ? "B-3"
				: $maskType =~ /PSR-50\/EB01/i ? "B-4"

				: $maskType =~ /RS-2000\s+Y\-8/i ? "C-1"
				: $maskType =~ /RS-2000\s+R\-3/i ? "C-2"
				: $maskType =~ /RS-2000\s+RM/i ? "C-3"
				: $maskType =~ /RS-2000\s+8G/i ? "C-4"
				: $maskType =~ /RS-2000\s+HFM/i ? "C-5"
				: $maskType =~ /RS-2000\s+4BL/i ? "C-6"
				: $maskType =~ /RS-2000\s+V\-5/i ? "C-7"

				: $maskType =~ /PM500\-K08/i ? "D-1"
				: $maskType =~ /PM500\-K08M/i ? "D-2" : 0;

	if (exists $self->{matrix}{'ts1'} && exists $self->{matrix}{'bs1'}) {
		$zhTxt .= "Layerpair=ts1/bs1 Thick=$B_THK Width=$sizeW Height=$sizeL Scale=0,0 Resist=$daihao align=outer Polarity=positive/positive"
	}
	elsif (exists $self->{matrix}{'ts1'} && ! exists $self->{matrix}{'bs1'}) {
		$zhTxt .= "Layerpair=ts1 Thick=$B_THK Width=$sizeW Height=$sizeL Scale=0 Resist=$daihao align=outer Polarity=positive"
	}	
	elsif (! exists $self->{matrix}{'ts1'} &&  exists $self->{matrix}{'bs1'}) {
		$zhTxt .= "Layerpair=bs1 Thick=$B_THK Width=$sizeW Height=$sizeL Scale=0 Resist=$daihao align=outer Polarity=positive"
	}

	if ($zhTxt ne "") {
		$zhTxt .= "\n";
	}

	
	if (exists $self->{matrix}{ts} && exists $self->{matrix}{bs}) {
		$zhTxt .= "Layerpair=ts/bs Thick=$B_THK Width=$sizeW Height=$sizeL Scale=0,0 Resist=$daihao align=outer Polarity=positive/positive"
	}
	elsif (exists $self->{matrix}{ts} && ! exists $self->{matrix}{bs}) {
		$zhTxt = "Layerpair=ts Thick=$B_THK Width=$sizeW Height=$sizeL Scale=0 Resist=$daihao align=outer Polarity=positive"
	}	
	elsif (! exists $self->{matrix}{ts} && ! exists $self->{matrix}{bs}) {
		$zhTxt = "Layerpair=bs Thick=$B_THK Width=$sizeW Height=$sizeL Scale=0 Resist=$daihao align=outer Polarity=positive"
	}

	if ($zhTxt ne "") {			
		$self->WriteFile($fileZH,$zhTxt);	
		if ($daihao =~ /^0/) {
			$self->tipMessage("提示","未取到防焊曝光代号,请检查",500,300);
		}
	}

}

#=========================================





#=========================================
sub output_culdi{
	my $self = shift;
	my $part = shift;
	print Dumper $self->{dialog}{$part};

	#网比
	$self->net_compare;


	my $list = $self->{dialog}{$part}{selLayers};
	my $step = $self->{dialog}{$part}{step};
	$self->open_step($step,"inch","yes");
	$self->get_step_profile($step);



	my $outName = "null";
	my $innerTxt = "";
	my $outerTxt = "";


	#-----ldi的只输出tgz与文档
	foreach my $lay (sort{$self->{matrix}{$a}{row}<=>$self->{matrix}{$b}{row}} keys %{$list} ) {
		#if ( $list->{$lay}{sel} != 1) {next;}
		if ($list->{$lay}{another} ne "") {
			my $another = $list->{$lay}{another};
			#foreach my $key (keys %{$list->{$lay}}) {
			#	$list->{$another}{$key} = $list->{$lay}{$key};
			#}
			#$list->{$another}{another} = $lay;
			my $xscale = sprintf ("%0.1f",$list->{$lay}{xscale});
			my $yscale = sprintf ("%0.1f",$list->{$lay}{yscale});
			my $pol = ($list->{$lay}{pol} =~ /正片/) ? "positive" :"negative";

			
			my $indent = ($self->{lay_count}{signal} <=2) ? "0,0" : "0.08,0.08";

			if ($list->{$lay}{innerOuter} =~ /内层/) {
				$innerTxt .= "Layerpair=$lay/$another Number=100 Thick=$list->{$lay}{xinthk} cu=$list->{$lay}{cuthk} Scale=$xscale,$yscale align=inner Polarity=$pol/$pol indent=$indent\n";
			}
			if ($list->{$lay}{innerOuter} =~ /外层/) {
				#$outerTxt .= "Layerpair=$lay/$another Number=100 Thick=$list->{$lay}{xinthk} cu=$list->{$lay}{cuthk} Scale=$xscale,$yscale align=outer Polarity=$pol/$pol indent=$indent\n";
				$outerTxt .= "Layerpair=$lay/$another Number=100 Thick=$list->{$lay}{xinthk}  Scale=0,0 align=outer Polarity=$pol/$pol indent=$indent\n";
			}
		}
	}
	#$self->output_tgz_file($innerTxt,$outerTxt); 改为输出gerber再输出，内层有修改加了拉伸系数
	#print "----------output_ldi end---------\n";


	#---输出外发的---
	foreach my $lay (sort{$self->{matrix}{$a}{row}<=>$self->{matrix}{$b}{row}} keys %{$list} ) {
		if ( $list->{$lay}{sel} != 1) {next;}

		
		my @layers = ($lay);
		if ($list->{$lay}{another} ne "") {
			my $another = $list->{$lay}{another};
			push @layers,$another;	
		}


		#---输出内层系数到OK中
		if ($self->{dialog}{culdi}{wf}=~ /内层/){
			if ($innerTxt ne "") {
				my $dir = "$self->{dialog}{OutputPath}/OK";
				$dir = encode('gb2312',$dir);
				make_path($dir);				
				my $fileInn = encode('gb2312',"/$self->{Job}_INNER.txt");
				$fileInn = $dir.$fileInn;
				$self->WriteFile($fileInn,$innerTxt);		
			}
		}


		#--外发内层
		if ($self->{dialog}{culdi}{wf}=~ /内层/ && $list->{$lay}{innerOuter} =~ /内层/) {

			foreach my $layer (@layers) {

				my $xscale = $self->change_ls_format($list->{$lay}{xscale});
				my $yscale = $self->change_ls_format($list->{$lay}{yscale}); #---变成万分之几的数字形式

				#~~~~~~~~~~~~~~~~~~~~~~~~ 加拉伸系数 
				$self->add_lsxs($layer,$xscale,$yscale);

		
				#$self->add_inner_ccd($layer,"add",$list->{$layer}{xscale},$list->{$layer}{yscale});  #---加6个ccd对位
				#  有out_scale的不拉伸，选缩回去
				$self->change_inner_ls($step,$layer,"new",$xscale,$yscale);



				my $outLayer = $layer;
				#--负片转正片
				my $nflag = 0;
				if ($list->{$lay}{pol} =~ /负片/ && $self->{matrix}{$layer}{polarity} =~/positive/i) {
					$outLayer = $self->change_negative_layer($step,$layer);
					$nflag = 1;
				}


				#---参数设置---------
				my $angle =  0;
				my $mir =    "no";
				my ($nf1,$nf2,$wheel,$compare) = (2,6,"","null");
				my ($report,$reread,$pfix,$sfix) = ("null","null","null","null");

			
				my $xyScal = ($xscale ==1 && $yscale == 1) ? "" : "\(X=${xscale}Y=${yscale}\)";
				$outName = "$self->{dialog}{OutputPath}/OK/$self->{Job}${xyScal}.${outLayer}";


		
				$self->out_Gerber_layer($part,$step,$outLayer,$outName,$xscale,$yscale,$nf1,$nf2,$mir,$angle,$wheel,$compare,$report,$reread,$pfix,$sfix);

				#$self->add_inner_ccd($layer,"delete",$list->{$layer}{xscale},$list->{$layer}{yscale});  #---删6个ccd对位

				if ($nflag) {
					$self->delete_layer($outLayer);
				}

				#  有out_scale的不拉伸，改回原层
				$self->change_inner_ls($step,$layer,"old");
			}
			print "----------waifa inner end---------\n";

			#---保存后用于下面输出tgz
			$self->VOF;
			$self->COM("check_inout,mode=out,type=job,job=$self->{Job}");
			$self->COM("save_job,job=$self->{Job},override=yes");
			$self->COM("check_inout,mode=in,type=job,job=$self->{Job}");
			$self->VOF;
		}
		#--外发外层
		elsif ($self->{dialog}{culdi}{wf}=~ /外层/ && $list->{$lay}{innerOuter} =~ /外层/) {

			foreach my $layer (@layers) {
				my $outLayer = $layer;
				my $nflag = 0;
				if ($list->{$lay}{pol} =~ /负片/ && $self->{matrix}{$layer}{polarity} =~/positive/i) {
					$outLayer = $self->change_negative_layer($step,$layer);
					$nflag = 1;
				}


				#---参数设置---------
				my $xscale = $self->change_ls_format($list->{$lay}{xscale});
				my $yscale = $self->change_ls_format($list->{$lay}{yscale}); #---变成万分之几的数字形式
				my $angle =  0;
				my $mir =    "no";
				my ($nf1,$nf2,$wheel,$compare) = (2,6,"","null");
				my ($report,$reread,$pfix,$sfix) = ("null","null","null","null");

			
				my $xyScal = ($xscale ==1 && $yscale == 1) ? "" : "\(X=${xscale}Y=${yscale}\)";
				#$outName = "$self->{dialog}{OutputPath}/OK/$self->{Job}${xyScal}-ccd.${layer}";
				$outName = "$self->{dialog}{OutputPath}/OK/$self->{Job}${xyScal}.${layer}";

				
				$self->out_Gerber_layer($part,$step,$outLayer,$outName,$xscale,$yscale,$nf1,$nf2,$mir,$angle,$wheel,$compare,$report,$reread,$pfix,$sfix);
			}
			print "----------waifa ounter end---------\n";
		}
	}

	$self->clear_layers();
	$self->editor_page_close;
	print "----------output_culdi end-----2----\n";

	$self->output_tgz_file($innerTxt,$outerTxt); #改为输出gerber再输出，内层有修改加了拉伸系数
	#print "----------output_ldi end---------\n";


}





#----输出txt与tgz文档
sub output_tgz_file{
	my $self = shift;
	my ($innerTxt,$outerTxt) = @_;


		
	my $dir = "$self->{dialog}{OutputPath}/tgz";
	$dir = encode('gb2312',$dir);

	make_path($dir);

	my $fileInn = encode('gb2312',"/$self->{Job}_INNER.txt");
	$fileInn = $dir.$fileInn;
	if ($innerTxt ne "") {			
		$self->WriteFile($fileInn,$innerTxt);		
	}


	my $fileOut = encode('gb2312',"/$self->{Job}_LDI.txt");
	$fileOut = $dir.$fileOut;
	if ($outerTxt ne "") {			
		$self->WriteFile($fileOut,$outerTxt);	
		$self->COM("export_job,job=$self->{Job},path=$dir,mode=tar_gzip,submode=full,overwrite=yes");
	}

}



#~~~~~~~~~~~~~~~~~~~~~~~~ 加拉伸系数 ~~~~~~~~~~~~~~~~~~~~~~~~#
sub set_lsxs_values{
	my $self = shift;
	$self->{lsxs}{x1} = $self->{PROF_xcenter} - 76.2/25.4 ; 
	$self->{lsxs}{y1} = $self->{PROF_ymin} +  0.10374; 
	$self->{lsxs}{x2} = $self->{lsxs}{x1} + 47/25.4 ; 
	$self->{lsxs}{y2} = $self->{lsxs}{y1};

	$self->{lsxs_txt}{x} = $self->{lsxs}{x1};
	$self->{lsxs_txt}{y} = $self->{lsxs}{y1}-1.7/25.4;
}

sub add_lsxs{
	my $self = shift;
	my ($layer,$scale_x,$scale_y) = @_;

	$self->affected_one_layer($layer);

	if (! exists $self->{lsxs}{x1} ) {
		$self->set_lsxs_values;
	}

	if ($scale_x  ==1) {
		$scale_x = '1.0000';
	}
	if ($scale_y  ==1) {
		$scale_y = '1.0000';
	}
	$self->{lsxs_text} = "X=$scale_x Y=$scale_y";


	my ($polPos,$polNeg) = ("positive",'negative');
	if ($self->{matrix}{$layer}{polarity} =~ /negative/i ) {
		($polPos,$polNeg) = ("negative","positive");
	}




	$self->COM("cur_atr_reset");
	$self->COM("cur_atr_set,attribute=.out_scale");	
	$self->add_line($self->{lsxs}{x1},$self->{lsxs}{y1},$self->{lsxs}{x2},$self->{lsxs}{y2},"s157.48",$polNeg,"yes");
	$self->add_text($self->{lsxs_txt}{x},$self->{lsxs_txt}{y},$self->{lsxs_text},0.098425,0.11811,1.5748,$polPos,0,"no","yes");
	$self->COM("cur_atr_reset");
}



sub change_inner_ls{
	my $self = shift;
	my $step = shift;
	my $layer = shift;
	my $action = shift;
	my ($xscale,$yscale) =@_;
	my $tmplayer = $layer."ls$$"; 
	if ($action =~ /new/) {
		$self->affected_one_layer($layer);
		$self->sel_copy_other($tmplayer,"no",0);
		$self->filter_reset;
		$self->filter_set_attribute(".out_scale");
		$self->filter_area_strt();
		if ($self->COM("get_select_count")) {
			my ($xsca,$ysca) = (2-$xscale,2-$yscale);
			$self->COM("sel_transform,mode=anchor,oper=scale,duplicate=no,x_anchor=0,\
						y_anchor=0,angle=0,x_scale=$xsca,y_scale=$ysca,x_offset=0,y_offset=0");
			
		}
		$self->filter_reset;
	}
	elsif ($action =~ /old/) {
		$self->copy_layer($step,$tmplayer,$layer);
		$self->delete_layer($tmplayer);
	}
}






#---转负片
sub change_negative_layer{
	my $self = shift;
	my $step = shift;
	my $layer = shift;
	my $nlayer = "n".$layer;
	my ($x1,$y1,$x2,$y2) = ($self->{PROF_xmin}-0.639,$self->{PROF_ymin}-0.16,$self->{PROF_xmax}+0.16,$self->{PROF_ymax}+0.16);

	if ($self->layer_EXISTS($step,$nlayer) =~ /yes/) {
		$self->delete_layer($nlayer);
	}
	$self->create_layer($nlayer);
	$self->affected_one_layer($nlayer); 
	$self->add_surf($x1,$y1,$x2,$y2,"positive","no");
	my $flateLayer = $layer."$$";
	$self->flatten_layer($layer,$flateLayer);
	$self->affected_one_layer($flateLayer); 
	$self->sel_copy_other($nlayer,"yes",0);
	$self->delete_layer($flateLayer);
	return $nlayer;
}






sub add_inner_ccd{
	my $self = shift;
	my $layer = shift;
	my $action = shift;
	my ($xscale,$yscale) = @_;
	$self->affected_one_layer($layer); 
	if ($action =~ /add/) {		
		my $sym = ($layer =~ /t$/) ? "in-ccd-t" : "in-ccd-b";
		$self->COM("cur_atr_reset");
		$self->COM("cur_atr_set,attribute=.string,text=tmptxt")	;
		$self->add_pad($self->{PROF_xcenter},$self->{PROF_ycenter},$sym,"negative",0,"yes");
		$self->COM("cur_atr_reset");

		#---把不拉伸的先缩
		$self->filter_reset;
		$self->filter_set_attribute(".string","tmptxt");
		$self->filter_area_strt();
		if ($self->COM("get_select_count")) {
			$self->COM("sel_break");				
		}
		$self->filter_reset;
		$self->filter_set_attribute(".string","tmptxt");
		$self->filter_area_strt();
		if ($self->COM("get_select_count")) {
			my ($xsca,$ysca) = (2-$xscale,2-$yscale);
			$self->COM("sel_transform,mode=anchor,oper=scale,duplicate=no,x_anchor=0,\
					y_anchor=0,angle=0,x_scale=$xsca,y_scale=$ysca,x_offset=0,y_offset=0");
		}
		$self->filter_reset;

	}
	else{
		$self->filter_reset;
		$self->filter_set_attribute(".string","tmptxt");
		$self->filter_area_strt();
		if ($self->COM("get_select_count")) {
			$self->sel_delete;
		}
	}


}




#=========================================
sub output_silkprint{
	my $self = shift;
	my $part = shift;






	#print Dumper $self->{dialog}{$part};
	my $list = $self->{dialog}{$part}{selLayers};
	my $step = $self->{dialog}{$part}{step};

	$self->open_step($step,"inch","yes");
	my $outName = "null";
	foreach my $layer (sort{$list->{$a}{row}<=>$list->{$b}{row}} keys %{$list} ) {
		if ( $list->{$layer}{sel} != 1) {next;}


		my ($flateLayer,$sigLayer,$ref) = $self->make_ref_layer($step,$layer);		
		#---参数设置---------
		my ($xscale,$yscale,$nf1,$nf2) = (1,1,6,6);
		my ($wheel,$compare) = ("","null");
		my ($angle,$mir) = ($self->{matrix}{$layer}{side} =~ /top/i) ? (90,"no") :  (270,"yes");

		my ($report,$reread,$pfix,$sfix) = ("null","null","null","null");


		#---输出gerber $flateLayer	
		$outName = "$self->{dialog}{OutputPath}/WT/$self->{Job}.$layer.g$layer";
		#---输出gerber
		$self->out_Gerber_layer($part,$step,$flateLayer,$outName,$xscale,$yscale,$nf1,$nf2,$mir,$angle,$wheel,$compare,$report,$reread,$pfix,$sfix);
		

		#---输出gerber $ref
		$wheel = "ss_ref_table";
		$outName = "$self->{dialog}{OutputPath}/WT/$self->{Job}.$sigLayer.g$sigLayer";		
		$self->out_Gerber_layer($part,$step,$ref,$outName,$xscale,$yscale,$nf1,$nf2,$mir,$angle,$wheel,$compare,$report,$reread,$pfix,$sfix);


		$self->delete_layer($ref);
		$self->delete_layer($flateLayer);
	}


	$self->clear_layers();
	$self->editor_page_close;
	if ($outName !~ /null/) {
		$self->write_zf_file; #---写字符的信息
		print "----------output_silkprint end---------\n";
	}
}



#----------
sub make_ref_layer{
	my $self = shift;
	my $step = shift;
	my $layer = shift;
	   
	#---字符层对应的外层
	my $sigLayer;
	my $side = $self->{matrix}{$layer}{side};
	foreach my $lay (sort {$self->{matrix}{$a}{row} <=> $self->{matrix}{$b}{row}} keys %{$self->{matrix}}) {
		if ($self->{matrix}{$lay}{context} =~ /board/i && $self->{matrix}{$lay}{layer_type} =~ /signal/i && $self->{matrix}{$lay}{side} =~ /$side/i) {
			$sigLayer = $lay;
		}
	}

	if (! defined  $sigLayer) {
		return;
	}

	AGAINREF:
	my ($optLayer,$ref,$flateLayer) = ("opt_tmp","$self->{Job}.${sigLayer}_opt.g$sigLayer","flater");
	$self->VOF;
	$self->delete_layer($optLayer);
	$self->delete_layer($ref);
	$self->delete_layer($flateLayer);
	$self->VON;



	#----处理symbol打散的
	$self->flatten_layer($layer,$flateLayer); 
	$self->VOF;
	$self->COM("sel_break");                     #---被负片挡到打散不了
	$self->VON;	



	$self->affected_one_layer($flateLayer); 
	$self->filter_reset;
	$self->filter_set_include_syms("barcode*");
	$self->filter_area_strt();
	if ($self->COM("get_select_count")) {
		$self->sel_delete;
	}



	$self->filter_reset;
	$self->filter_set_feat_types("line\;pad");
	$self->filter_set_include_syms("r0");
	$self->filter_area_strt();
	if ($self->COM("get_select_count")) {
		$self->sel_move_other($optLayer,"no",0);
	}
	else{
		$self->create_layer($optLayer);
	}
	$self->affected_one_layer($optLayer);
	

	#---加入对位光点
	my @gd = ();
	my $tmpfilet  = $self->FEATURES($step,$sigLayer);
	my $lines = $self->ReadFile($tmpfilet);
	unlink $tmpfilet;
	foreach my $line (@{$lines}) {
		if ($line =~ /^#P/i) {
			my @all = split /\s+/,$line;
			if ($all[3] =~ /^qd_ss_ccd$/) {
				push @gd,[$all[1],$all[2]];
			}
		}
	}
	 


	$self->COM("cur_atr_reset");
	$self->COM("cur_atr_set,attribute=.out_flag,text=999,int=999");
	foreach my $one (@gd) {
		$self->add_pad($one->[0],$one->[1],"r0","positive",0,"yes");
	}
	$self->COM("cur_atr_reset");



	my $tmpFile  = $self->FEATURES_feat_index($step,$optLayer,'mm');
	my $P = $self->ReadFile($tmpFile);	
	unlink $tmpFile;


	
	#---找带有flag的物件且r0的物件
	my %flag;
	foreach my $line (@{$P}) {
		if ($line !~ /#L|#P/) {
			next;
		}
			
		if ($line !~ /\sr0\s/) {
			next;
		}

		if ($line !~ /out_flag/) {
			next;
		}
		my ($index,$size) = $line =~ /^#(\d+).*\.out_flag=(\d+)/;	
		$flag{$size}++;
	}

	if (! exists $flag{'233'}) {
		$self->PAUSE("$layer NO r0 guandian,add please");
		goto AGAINREF;
	}

	if ( $flag{'233'} != 4) {
		$self->PAUSE("$layer the count r0 guandian !=4,Check");
		goto AGAINREF;
	}




	#----按flag大小更改物件
	$self->units("mm");
	foreach my $size (keys %flag) {
		$self->filter_reset;
		$self->filter_set_include_syms("r0");
		$self->COM("filter_atr_set,filter_name=popup,condition=yes,attribute=.out_flag,min_int_val=$size,max_int_val=$size");
		$self->filter_area_strt();
		if ($self->COM("get_select_count")) {
			$self->sel_change_sym("r$size");
			$self->filter_reset;
			$self->filter_set_include_syms("r$size");
			$self->COM("filter_atr_set,filter_name=popup,condition=yes,attribute=.out_flag,min_int_val=$size,max_int_val=$size");
			$self->filter_area_strt();
			if ($self->COM("get_select_count")) {
				$self->sel_move_other($ref,"no",0);
			}
		}
	}
	$self->units("inch");
	$self->delete_layer($optLayer);

	#---建立D码表
	$self->defined_d_code(\%flag);


	return $flateLayer,$sigLayer,$ref;
}

#---建D码表 ss_ref_table
sub defined_d_code{
	my $self = shift;
	my $flag = shift;
	$self->VOF;
	$self->COM("delete_entity,job=$self->{Job},type=wheel,name=ss_ref_table");	
	$self->COM("create_entity,job=$self->{Job},is_fw=no,type=wheel,name=ss_ref_table,db=,fw_type=form");
	$self->VON;

	$self->COM("open_entity,job=$self->{Job},type=wheel,name=ss_ref_table,iconic=yes");
	$self->COM("wheel_current,job=$self->{Job},wheel=ss_ref_table");
	$self->COM("wheel_units,type=mm");

	foreach my $dcode (keys %{$flag}) {
		$self->COM("wheel_set_dcode,dcode=$dcode,symbol=r$dcode,line=-1");
	}
	$self->COM("wheel_page_close");
}





#---写字符的信息
sub write_zf_file{
	my $self = shift;
	my $dir = "$self->{dialog}{OutputPath}/tgz";
	$dir = encode('gb2312',$dir);
	make_path($dir);
	
	my $B_THK = $self->{jobUserInfo}{'板厚'};
	my $sizeL =  $self->{jobUserInfo}{'板长'};
	my $sizeW =  $self->{jobUserInfo}{'板宽'};
	my $size = $sizeW.'*'.$sizeL;

	
	my $zfTxt = "";
	my $fileZF = encode('gb2312',"/$self->{Job}_ZF.txt");
	$fileZF = $dir.$fileZF;
	
	if (exists $self->{matrix}{to} && exists $self->{matrix}{bo}) {
		$zfTxt = "Layerpair=to/bo Size=$size Thickness=$B_THK Printmode=1 Datecode=0"
	}
	elsif (exists $self->{matrix}{to} && ! exists $self->{matrix}{bo}) {
		$zfTxt = "Layerpair=to Size=$size Thickness=$B_THK Printmode=1 Datecode=0"
	}
	elsif (! exists $self->{matrix}{to} &&  exists $self->{matrix}{bo}) {
		$zfTxt = "Layerpair=bo Size=$size Thickness=$B_THK Printmode=1 Datecode=0"
	}

	if ($zfTxt ne "") {			
		$self->WriteFile($fileZF,$zfTxt);		
	}
}

#============================================
#============================================
#============================================

sub output_mifile{
	my $self = shift;
	my $part = shift;
	#print Dumper $self->{dialog}{$part};


	my $step =  "pnl";
	#my $step = $self->{dialog}{$part}{step};
	$self->open_step($step,"inch","yes");
	$self->get_step_profile($step);



	my $outName = "$self->{dialog}{OutputPath}/mi/$self->{Job}.txt";	
	$outName  = encode('gb2312',$outName);
	my $dir = dirname $outName;
	make_path($dir);
   
    #---插入到 MES 的列表
    $self->{upMesInfo} = {};
  
	my $line = "生产型号:$self->{Job}\n";

	#---获取板厚
	my $thk = $self->{jobUserInfo}{'板厚'};
	$line .= "成品板厚(MM): $thk\n";

	my $sizex = sprintf("%0.2f",$self->{PROF_xmax}*25.4);
	my $sizey = sprintf("%0.2f",$self->{PROF_ymax}*25.4);
	$line .= "拼版尺寸(MM): $sizex  X $sizey\n";

	my $data = $self->get_set_ok_count($step);
	$line .= "单只尺寸(MM): $data->{ok}{size}\n";
	if (exists $data->{set}) {
		$line .= "SET 尺寸(MM): $data->{set}{size}\n";
		$line .= "1PNL=$data->{set}{count} SET\n";
		$line .= "1SET=$data->{ok}{count} Units\n";
	}
	else{
		$line .= "1PNL=$data->{ok}{count} Units\n";
	}


    $self->{area} = {};#--上传面积到 MES 初始化变量 rick 2022/12/2

	#---测面积
	#---内层百分比  #--- 外层
	#=============
	my ($outp,$innerp,$maskp) = $self->measure_area($step);
	foreach my $one (@{$outp}) {
		my ($layer,$total,$percent) = @{$one};
		$line .= "${layer}铜面积\: \【 ${total}\】,百分比:\【${percent}\%\】\n";
		if ($layer =~ /tl/) {
			$self->{upMesInfo}{tl_total}   = $total;#---铜面积 上传MES 用
			$self->{upMesInfo}{tl_percent} = $percent;#---铜面积 上传MES 用
		}
		elsif ($layer =~ /bl/) {
			$self->{upMesInfo}{bl_total}   = $total;#---铜面积 上传MES 用
			$self->{upMesInfo}{bl_percent} = $percent;#---铜面积 上传MES 用
		}
	}
	my $m = 0;
	my $preTotol = 0;
	my $pinj = 0;
	foreach my $one (@{$innerp}) {
		my ($layer,$total,$percent) = @{$one};
		$line .= "${layer}铜面积\: \【${percent}\%\】\n";
		$m++;
		$preTotol = $preTotol+$percent;
		$pinj = 100-$preTotol/$m;
	}
	$line .= "内层铜损\(平均值\)\:\【${pinj}\%\】\n";
     
	#---内层铜损 上传MES 用
	$self->{upMesInfo}{inner_tonshun} = $pinj;#---内层铜损 上传MES 用

	#=============
	foreach my $layer (sort{$self->{matrix}{$a}{row}<=>$self->{matrix}{$b}{row}} keys %{$self->{matrix}} ) {
		if ($self->{matrix}{$layer}{context} =~ /board/i && $self->{matrix}{$layer}{side} =~ /inner/i) {
			my %h;
			my @da = ();
			my @da_by = ();
			my @pzk_ba = ();
			my $tmpfile  = $self->FEATURES($step,$layer);
			my $lines = $self->ReadFile($tmpfile);
			unlink $tmpfile;
			foreach my $line (@{$lines}) {
				if ($line =~ /^#P/) {
					my ($x,$y,$sym) = (split /\s+/,$line)[1,2,3];


					if ($sym =~ /^qd_int$|^qd_inb$/) {
						if ($x<$self->{PROF_xcenter} && $y <$self->{PROF_ycenter}) {
							($h{ld}{x},$h{ld}{y}) = ($x,$y);
						}
						elsif ($x<$self->{PROF_xcenter} && $y >$self->{PROF_ycenter}) {
							($h{lu}{x},$h{lu}{y}) = ($x,$y);
						}
						elsif ($x>$self->{PROF_xcenter} && $y >$self->{PROF_ycenter}) {
							($h{ru}{x},$h{ru}{y}) = ($x,$y);
						}
						elsif ($x>$self->{PROF_xcenter} && $y <$self->{PROF_ycenter}) {
							($h{rd}{x},$h{rd}{y}) = ($x,$y);
						}
					}
					
					if ($sym =~ /^qd_daba$/) {
						push @da,[$x,$y];
					}

					if ($sym =~ /^qd_daba_by$/) {
						push @da_by,[$x,$y];
					}

					if ($sym =~ /^qd_daba_45$/) {
						push @pzk_ba,[$x,$y];
					}
				
				}
			}

			if (%h) {
				my $wide = sprintf ("%0.2f",($h{ru}{x}-$h{ld}{x})*25.4);
				my $long = sprintf ("%0.2f",($h{ru}{y}-$h{ld}{y})*25.4);
				$line .= "偏位检测环数据\：\【${wide}\*${long}mm\】\n";
			}
			if (@pzk_ba) {
				@pzk_ba = sort {$a->[1]<=>$b->[1]} @pzk_ba;
				@pzk_ba = sort {$a->[0]<=>$b->[0]} @pzk_ba;
               


				my $pzkwide = sprintf ("%0.2f",($pzk_ba[1][0]-$pzk_ba[0][0])*25.4);
				my $pzklong = abs(sprintf ("%0.2f",($pzk_ba[1][1]-$pzk_ba[0][1])*25.4));

				#foreach my $line (@pzk_ba) {
				#	$self->PAUSE("wide:$pzkwide long:$pzklong===@$line");
				#}

				#--
				$self->{upMesInfo}{pzk_xray} = "${pzkwide}*${pzklong}";#---盘中孔(菱形靶标) 上传MES 用

	
			}
			if (@da) {
				@da = sort {$a->[1]<=>$b->[1]} @da;
				@da = sort {$a->[0]<=>$b->[0]} @da;

				@da_by = sort {$a->[0]<=>$b->[0]} @da_by;

				my $wide = sprintf ("%0.2f",($da[1][0]-$da[0][0])*25.4);
				my $long = abs(sprintf ("%0.2f",($da[1][1]-$da[0][1])*25.4));

				my $wide_by = sprintf ("%0.2f",($da_by[-1][0]-$da_by[0][0])*25.4);


				my $JOB = uc $self->{Job};
				$self->get_layers_count;
				my $count =  $self->{lay_count}{signal};
				if (exists $self->{upMesInfo}{pzk_xray}) {
					$line .= "通孔xray\(方形靶标\) \【${wide}*${long}mm\】副靶孔\:Ray\:\【${wide_by}mm\】盘中孔\(菱形靶标\)\【$self->{upMesInfo}{pzk_xray}\】1-${count}铣边工具编号:\【${JOB}-DXF1-${count}.ROU\】\n";
				}else{
				    $line .= "通孔xray\(方形靶标\) \【${wide}*${long}mm\】副靶孔\:Ray\:\【${wide_by}mm\】1-${count}铣边工具编号:\【${JOB}-DXF1-${count}.ROU\】\n";	
				}
				
				$self->{upMesInfo}{all_xray} = "${wide}*${long}";#---通孔xray 上传MES 用

				$self->{upMesInfo}{back_target} = "${wide_by}";#---副靶孔 上传MES 用


				last;
			}
		}
	}


	
	#==================
	$m = 0;
	my $pre = 0;
	my $goldAllTotl = 0;
	my $golAllpinj = 0;

	my $goldPerTotl= 0;
	my $goldPerpinj= 0;

	foreach my $one (@{$maskp}) {
		my ($layer,$total,$percent) = @{$one};
		$line .= "${layer}沉金面积\:\【${total}平方毫米\】,百分比\:\【${percent}\%\】\n";
		$m++;
		$goldAllTotl  = $goldAllTotl + $total;
		$golAllpinj = $goldAllTotl/$m;

		$goldPerTotl = $goldPerTotl+$percent;
		$goldPerpinj = $goldPerTotl/$m;
	}
	$line .= "平均沉金面积\:\【${golAllpinj}平方毫米\】,百分比\:\【${goldPerpinj}\%\】\n";
	$line .= "总和沉金面积\:\【${goldAllTotl}平方毫米\】,百分比\:\【${goldPerTotl}\%\】\n";

	$self->{upMesInfo}{golAllpinj} = "${golAllpinj}";#---平均沉金面积 上传MES 用
	$self->{upMesInfo}{goldAllTotal} = "${goldPerTotl}";#---总和沉金面积 上传MES 用

	$line  = encode('gb2312',$line);
	$self->WriteFile($outName,$line);

	$self->clear_layers();
	$self->editor_page_close;
    
	#---这里上传电镀面积到 MES
	$self->UpLoadCopperAreaToMes($step);

	#---上传基本信息时连接 MES
	$self->upLoadBaseInfoToMes();
}


#----
sub change_ls_format{
	my $self = shift;
	my $data = shift;
	$data = $data/10000+1;
	return $data;
}



sub delete_old_folder{
	my $self = shift;
	#ori资料  $self->{dialog}{OutputPath}/orig_film";
	#cnc资料  $self->{dialog}{OutputPath}/cnc
	#线路ldi   $self->{dialog}{OutputPath}/tgz $self->{dialog}{OutputPath}/OK
	#阻焊     $self->{dialog}{OutputPath}/OK
	#字符     $self->{dialog}{OutputPath}/OK
	#字符打印机  $self->{dialog}{OutputPath}/WT
	#钢网       $self->{dialog}{OutputPath}/钢网文件和生产文件${kedama}
	#pdf_dxf  $self->{dialog}{OutputPath}/mi
	#封边文档  $self->{dialog}{OutputPath}/mi


	my $oldDir;
	foreach my $part (@{$self->{all_part}}) {
		if ($self->{dialog}{$part}{sel} ) {
			if ($part =~ /orig/i) {
				$oldDir = "$self->{dialog}{OutputPath}/orig_film";			
			}
			elsif ($part =~ /drl/i) {
				my $oldDir = "$self->{dialog}{OutputPath}/cnc";
				remove_tree($oldDir);
			}
			elsif ($part =~ /culdi/i) {
				$oldDir = "$self->{dialog}{OutputPath}/tgz";
				if ($self->{dialog}{culdi}{wf} ne "") {    #----有重新输出外发资料
					my $oldDir2 = "$self->{dialog}{OutputPath}/OK";
					$oldDir2 = encode('gb2312',$oldDir2);
					remove_tree($oldDir2);
				}
			}
			elsif ($part =~ /mask|silk/i) {
				$oldDir = "$self->{dialog}{OutputPath}/OK";
			}
			elsif ($part =~ /silkprint/i) {
				$oldDir = "$self->{dialog}{OutputPath}/WT";
			}

			elsif ($part =~ /pdf|mifile/i) {
				$oldDir = "$self->{dialog}{OutputPath}/mi";
			}
			elsif ($part =~ /guanwan/i) {
				my $kedama  = $self->{jobUserInfo}{'客户型号'};
				$oldDir = "$self->{dialog}{OutputPath}/钢网文件和生产文件${kedama}";
			}

			$oldDir = encode('gb2312',$oldDir);
			remove_tree($oldDir);
		}
	}
}









#
#生产型号: s316197c04a0
#成品板厚(MM): 2.0
#拼版尺寸(MM): 470.00 X 620.00
#单只尺寸(MM): 275.00 X 344.00
#tl铜面积: 【 2.056】 , 百分比:【64%】
#bl铜面积: 【 1.924】 , 百分比:【60%】
#l2t铜面积: 【77.36%】
#l3b铜面积: 【74.56%】
#内层铜损（平均值）:【24.04%】

#tl沉金面积:【22677.241平方毫米】,百分比:【7.591%】
#bl沉金面积:【18578.475平方毫米】,百分比:【6.219%】

#平均沉金面积:【20627.858平方毫米】,百分比:【6.905%】
#总和沉金面积:【41255.716平方毫米】,百分比:【13.810%】


#============================================
#============================================

1;

