#!/usr/bin/perl

=head
     01/29/16 HongBaiQing
=cut

package OutputRout;

use strict;
use warnings;
use Encode;
use File::Basename;
use File::Copy;
use File::Path qw(make_path);
use utf8;
#=====================================================
#=======================================
#-----------锣带部分----------
sub output_rout_part{
	my $self = shift;


	if ($self->{dialog}{rout_part} == 0) {
		return;
	}

	my $outName = "null";
	foreach my $layer (sort{$self->{list}{$a}{row}<=>$self->{list}{$b}{row}} keys %{$self->{list}} ) {
		if ($self->{list}{$layer}{new_type} !~ /rout_part/ || $self->{list}{$layer}{sel} != 1) {
			next;
		}

		if ($layer =~ /rou/) {
			#---设置参数
			#$self->COM("matrix_layer_context,job=$self->{Job},matrix=matrix,layer=$layer,context=board");
			#$self->COM("matrix_layer_type,job=$self->{Job},matrix=matrix,layer=$layer,type=rout");

			my $type = "rout";
			my $angle = $self->{list}{$layer}{angle};
			my $mir = $self->{list}{$layer}{mir};
			my $compare = ($self->{dialog}{reread} == 1) ? "compare" :"null";
			my ($xscale,$yscale) = ($self->{list}{$layer}{xscale},$self->{list}{$layer}{yscale});
			$outName =  "$self->{dialog}{OutputPath}/$self->{abName}$self->{Job}.多层锣边/$self->{Job}.panel_rou";
			$self->out_rout($type,$outName,$self->{Step},$layer,$mir,$angle,$xscale,$yscale,$outName,$compare);
		}
		if ($layer =~ /pin/) {
			#---参数设置---------
			my $type = "rout";
			$self->COM("matrix_layer_type,job=$self->{Job},matrix=matrix,layer=$layer,type=drill");
			my ($xscale,$yscale) = ($self->{list}{$layer}{xscale},$self->{list}{$layer}{yscale});
			my ($angle,$mir) = ($self->{list}{$layer}{angle},$self->{list}{$layer}{mir});
			my ($xori,$yori) = (0,0);
			$outName =  "$self->{dialog}{OutputPath}/$self->{abName}$self->{Job}.多层锣边/$self->{Job}.txt";
			my $report =  "null"; 
			my $compare = ($self->{dialog}{reread} == 1) ? "null" :"null";
			my $addLastHole = "null";
			$self->out_drill($type,$self->{Step},$layer,$mir,$angle,$xori,$yori,$xscale,$yscale,$outName,$compare,$report,$addLastHole);
		}
	}

	if ($outName !~ /null/) {
		print "----------output_rout_part end---------\n";
	}	
}
#-----------锣带部分-end--------
#=======================================
#===============================================
#$self->out_rout($type,$outPath,$step,$layer,$mir,$angle,$xscale,$yscale,$outName,$compare);
sub out_rout{
	my $self = shift;
	my ($type,$outPath,$step,$layer,$mir,$angle,$xscale,$yscale,$outName,$compare) = @_;
	my $file = "C:/tmp/${layer}_$$";

	$outName = encode('gb2312',$outName);

	$self->VOF;
	$self->COM("ncset_delete,name=1");
	$self->VON;
	$self->COM("ncrset_cur,job=$self->{Job},step=$step,layer=$layer,ncset=1");
	#$self->COM("ncr_set_machine,machine=default_excellon,thickness=0");
	$self->COM("ncr_set_machine,machine=excellonr,thickness=0");
	$self->COM("ncr_auto_all,create_rout=no");
	$self->COM("ncrset_units,units=inch");
	#---加上这句选什么机器都没关系了
	#$self->COM("ncr_set_params,format=excellon2,zeroes=trailing,units=mm,tool_units=mm,nf1=3,nf2=3,decimal=no,modal_coords=no,single_sr=no,sr_zero_set=no,repetitions=sr,drill_layer=rt2drl,sr_zero_drill_layer=drill,break_sr=no,ccw=no,short_lines=none,press_down=yes,last_z_up=16,max_arc_ang=180,sep_lyrs=no,allow_no_chain_f=no,keep_table_order=no");		
	$self->COM("ncr_register,angle=$angle,mirror=$mir,xoff=0,yoff=0,version=1,xorigin=0,yorigin=0,xscale=$xscale,yscale=$yscale,xscale_o=0,yscale_o=0");		
	$self->COM("ncr_cre_rout");
	$self->COM("ncrset_units,units=inch");
	$self->COM("ncr_ncf_export,dir=C:/tmp,name=${layer}_$$");	
	if (! -e $file) {
		push @{$self->{error}},"output->${step}->${layer} 失败";
		return "error";
	}


	#--不加上G93X0Y0指令 删掉G93X0Y0与F100S6000 CP开头的
	$self->addgxy($file);


	my $dir = dirname $outName;
	make_path($dir);

	#---读入对比
	if ($compare =~ /compare/) {
		my $outLayer = "${layer}_$$";
		$self->COM("input_manual_reset");
		$self->COM("input_manual_set,path=$file,job=$self->{Job},step=$step,format=Excellon2,data_type=ascii,units=mm,\
					 coordinates=absolute,zeroes=trailing,nf1=3,nf2=3,decimal=no,separator=nl,tool_units=mm,layer=$outLayer,wheel=,\
					 wheel_template=,nf_comp=0,multiplier=1,signed_coords=no,break_sr=yes,drill_only=no,merge_by_rule=no");
		$self->COM("input_manual,script_path=");


		$self->work_affected_layer($outLayer);
		#--镜像回去
		if ($mir =~ /yes/i) {
			$self->COM("sel_transform,mode=anchor,oper=mirror,duplicate=no,x_anchor=0,
				y_anchor=0,angle=0,x_scale=1,y_scale=1,x_offset=0,y_offset=0");
		}


		#---涨缩值缩涨回去
		if ($xscale != 1 || $yscale != 1) {
			$xscale = 1/$xscale;
			$yscale = 1/$yscale;
			$self->COM("sel_transform,mode=anchor,oper=scale,duplicate=no,x_anchor=0,y_anchor=0,angle=0,
			         x_scale=$xscale,y_scale=$yscale,x_offset=0,y_offset=0");
		}

		#---不是0度旋转
		$angle =   ($angle == 90) ? 270 
				 : ($angle == 180) ? 180 
				: ($angle == 270) ? 90  : 0;	 
		 if ($angle) {
			 $self->COM("sel_transform,mode=anchor,oper=rotate,duplicate=no,x_anchor=0,
				y_anchor=0},angle=$angle,x_scale=1,y_scale=1,x_offset=0,y_offset=0");
		}

		my $map = "${layer}_map";
		$self->COM("compare_layers,layer1=$outLayer,job2=$self->{Job},step2=$step,layer2=$layer,\
                layer2_ext=,tol=1,area=global,ignore_attr=,map_layer=$map,map_layer_res=200");
		my $diff = $self->{COMANS};

		unless($diff) {
			move ($file,$outName) or die "$!";
			$self->delete_layer($outLayer);
			$self->delete_layer($map);			
		}
		else{
			unlink $file;
			push @{$self->{error}},"output->${step}->${layer} 读入对比不一样";
			$self->delete_layer($map);
			print "output->${step}->${layer} diff-------------------\n";
			return "error";
		}
	}
	else{
		move ($file,$outName) or die "$file copy failed $!"; 
	}
}


sub addgxy{
	my $self = shift;
	my $oldFile = shift;
	my $nemFile = "C:/tmp/file2.$$";
	open (FILE_W,">$nemFile") or die" can't open $nemFile, $!";
	open (FILE,"$oldFile")      or die" can't open $oldFile $!";
    while (<FILE>) {
	    chomp;
		my $line = $_;
        if ($line =~ /^F100S6000|^G93X0Y0|^CP/i) { 
			next;
        }
		if ($line =~ /^(T\d{2})\d{2,3}$/) {
			$line = $1;
		}

       if (/\%/) {
          # $_ = "G93X0Y0\n$_";
        }
        print FILE_W "$line\n";
    }
    close FILE;
    close FILE_W;
    move ($nemFile,$oldFile) or die "$nemFile copy failed $!"; 
}



1;

