#!/usr/bin/perl

=head
=cut

package drill_erp;

use strict;
use warnings;
use Encode;
use File::Basename;
use File::Copy;
use File::Path qw(make_path);
use utf8;
use Time::localtime;
use Data::Dumper;
#============================
##################################################################################
##################################################################################

#=======================================================================

sub make_drill_report{
	my $self = shift;
	my ($pnlStep,$layer,$drlFile) = @_;




	my $ha = {};

	#-----计算拼板内各step个数
	my %stepCount;
	$stepCount{$pnlStep} =1;
	$self->get_allsteps($self->{Job},$pnlStep,\%stepCount);  
	#print Dumper \%stepCount;

	

	 #--获取某一层钻孔信息
	foreach my $step (keys %stepCount) {
		$self->get_layer_holes_info($ha,$step,$layer,\%stepCount);    
	}
	#print Dumper $ha;

    #    0    1     2       3       4     5     6       7        8
	#  [$fz,$type,$tolMax,$tolMin,$long,$step,$count,$drillTime,$type2]
	#print Dumper $ha;

	#---合并step里面相同的
	foreach my $dz (keys %{$ha}) {
		if (@{$ha->{$dz}{info}}>1){
			for my $i(0..$#{$ha->{$dz}{info}}) {
				my ($fz,$type,$maxtol,$mintol,$long,$ste) = @{$ha->{$dz}{info}[$i]}; 
				my $type2 = $ha->{$dz}{info}[$i][8];
				for my $j($i+1..$#{$ha->{$dz}{info}}) {
					my ($fz_n,$type_n,$maxtol_n,$mintol_n,$long_n,$ste_n) = @{$ha->{$dz}{info}[$j]};
					my $type2_n = $ha->{$dz}{info}[$j][8];
					if ($fz eq $fz_n && $type eq $type_n && $maxtol eq $maxtol_n && $mintol eq $mintol_n && $long eq $long_n && $ste eq $ste_n && $type2 eq $type2_n) {						
						$ha->{$dz}{info}[$j][6] = $ha->{$dz}{info}[$i][6]+$ha->{$dz}{info}[$j][6]; #---孔数加上
						$ha->{$dz}{info}[$i] = ["null"];
						last;
					}				
				}
			}

			my @all = ();
			foreach my $P (@{$ha->{$dz}{info}}) {
				if (! grep /null/,@{$P} ) {
					push @all,[@{$P}]
				}
			}
			@{$ha->{$dz}{info}} = @all;
			@{$ha->{$dz}{info}} = sort{$a->[0]<=>$b->[0]} @{$ha->{$dz}{info}};
		}	
	}


	#print Dumper $ha;	


	#---合并ok set 合并一起， 阻抗条合并在一起，  
	foreach my $dz (keys %{$ha}) {
		if (@{$ha->{$dz}{info}}>1){
			for my $i(0..$#{$ha->{$dz}{info}}) {
				my ($fz,$type,$maxtol,$mintol,$long,$ste) = @{$ha->{$dz}{info}[$i]};
				my $type2 = $ha->{$dz}{info}[$i][8];
				for my $j($i+1..$#{$ha->{$dz}{info}}) {
					my ($fz_n,$type_n,$maxtol_n,$mintol_n,$long_n,$ste_n) = @{$ha->{$dz}{info}[$j]};
					my $type2_n = $ha->{$dz}{info}[$j][8];
					if ($fz eq $fz_n && $type eq $type_n && $maxtol eq $maxtol_n && $mintol eq $mintol_n && $long eq $long_n && $type2 eq $type2_n && $ste =~ /ok|set/ && $ste_n =~ /ok|set/) {						
						$ha->{$dz}{info}[$j][6] = $ha->{$dz}{info}[$i][6]+$ha->{$dz}{info}[$j][6]; #---孔数加上
						$ha->{$dz}{info}[$j][5] = $ha->{$dz}{info}[$i][5]."&".$ha->{$dz}{info}[$j][5]; #---step 接上
						$ha->{$dz}{info}[$i] = ["null"];
						last;
					}
					if ($fz eq $fz_n && $type eq $type_n && $maxtol eq $maxtol_n && $mintol eq $mintol_n && $long eq $long_n && $type2 eq $type2_n && $ste !~ /ok|set|pnl/ && $ste_n !~  /ok|set|pnl/) {						
						$ha->{$dz}{info}[$j][6] = $ha->{$dz}{info}[$i][6]+$ha->{$dz}{info}[$j][6]; #---孔数加上
						$ha->{$dz}{info}[$j][5] = $ha->{$dz}{info}[$i][5]."&".$ha->{$dz}{info}[$j][5]; #---step 接上
						$ha->{$dz}{info}[$i] = ["null"];
						last;
					}					

				}
			}

			my @all = ();
			foreach my $P (@{$ha->{$dz}{info}}) {
				if (! grep /null/,@{$P} ) {
					push @all,[@{$P}]
				}
			}
			@{$ha->{$dz}{info}} = @all;
			@{$ha->{$dz}{info}} = sort{$a->[0]<=>$b->[0]} @{$ha->{$dz}{info}};
		}	
	}



    #    0    1     2       3       4     5     6       7         8
	#  [$fz,$type,$tolMax,$tolMin,$long,$step,$count,$drillTime,$type2]]
	#---合并尾孔与单元的  
	foreach my $dz (keys %{$ha}) {
		my $flag = 0;
		if (@{$ha->{$dz}{info}}>1){
			for my $i(0..$#{$ha->{$dz}{info}}) {
				 if ($ha->{$dz}{info}[$i][5] =~ /pnl/ && $ha->{$dz}{info}[$i][6] == 1) {					
					$flag =  1;
					$ha->{$dz}{info}[$i] = ["null"];
					last;
				 }
			}

			my @all = ();
			foreach my $P (@{$ha->{$dz}{info}}) {
				if (! grep /null/,@{$P} ) {
					push @all,[@{$P}]
				}
			}
			@{$ha->{$dz}{info}} = @all;			
			@{$ha->{$dz}{info}} = sort{$a->[0]<=>$b->[0]} @{$ha->{$dz}{info}};
			if ($flag) {
				$ha->{$dz}{info}[0][6] = $ha->{$dz}{info}[0][6] +1;
			}		
		}
	}

	#---
	# 0         1    2    3     4    5      6        7        8        9       10      11     12           13           14       15
	#成品钻咀  Y/N   +    -    long  step   孔数   条孔钻数  $type2  remark   tNUM    num    钻刀   合并十一公并  条孔成品长   条孔钻后长
	#print Dumper $ha;	


	my $toder = $self->get_size_to_t($drlFile);
	my @exT = ();
	foreach my $dz (keys %{$ha}) {
		foreach my $P (@{$ha->{$dz}{info}}) {
			
			for my $k(9..15) {
				$P->[$k]  = "";
			}
				

			if ($P->[4] > 0) {  #--有长度是条孔 			
				my $size = $dz;
				$size =~ s/\d$/0/g;  #----去掉 尾数;
				my $maxlong = sprintf("%0.3f",$P->[4]+$size);
				my $cpLong = sprintf("%0.3f",$P->[4]+$P->[0]);  #---成品条孔长
				#$P->[8] = encode('gb2312',"槽孔");
				$P->[9] .= "槽孔";
				$P->[14] = $cpLong;
				$P->[15] = $maxlong;
			}
			else{     #---圆孔----------
				my $txt = "";
				if ($dz =~ /0.508/ && $P->[6] >100) {
					$P->[9] .= "型号孔";  #$txt .= encode('gb2312',"型号孔");					
					$P->[6] = 0;
				}

				if ($dz =~ /3.175/ ) {
					$P->[9] .= "靶孔";
				}

				if ($dz =~ /1.15/ && $P->[5] !~ /pnl/ && $P->[6] == 3) {
					$P->[9] .= "切片孔";
				}

				if ($dz  =~ /3.15/){
					if ($P->[6] == 8) {
						$P->[9] .="阻焊对位孔";
					}
					else{
						$P->[9] .="含阻焊对位孔";
					}
				}

				if ($dz  =~ /3.201/) {
					$P->[9] .="工具孔";
				}


				if ($P->[5] !~ /ok|set/ && $P->[5] !~ /pnl/) {
					$P->[9] .= "阻抗孔";
				}
			}

			$P->[10] = $toder->{$dz};
			my $order = $toder->{$dz};
			$order =~ s/^T0|^T//g;
			$P->[11] =$order;
			$P->[12] =$dz;
			$P->[13] = '+'.$P->[2].'/-'.$P->[3];
			push @exT,[@{$P}];
		}
	}
	
	@exT = sort {$a->[11]<=>$b->[11]} @exT;
	#print Dumper \@exT;

    

    my $holeMinSize = 0;#--上传需获取钻孔最小孔,

	#----写入user文件
	my %upTool  = ();#--统计上传的刀序,去除重叠的孔
	my @EMSTool = ();#--上传EMS使用
	my $lineTxt = "";
	my $k = 0;
	for my $i (0..$#exT) {
		$lineTxt .= "finishSize=$exT[$i][0];type=$exT[$i][1];type2=$exT[$i][8];tolz=$exT[$i][2];tolf=$exT[$i][3];count=$exT[$i][6];remark=$exT[$i][9];tnum=$exT[$i][10];drillSize=$exT[$i][12];finishSlot=$exT[$i][14];drillSlot=$exT[$i][15];slotHit=$exT[$i][7]\n";
		if ($holeMinSize == 0) {
			$holeMinSize = $exT[$i][12];
		}elsif($holeMinSize > $exT[$i][12]){
			$holeMinSize = $exT[$i][12];
		}
		my $tnum = $exT[$i][10];

	    if (exists $upTool{$tnum}) {
			my $curk = $EMSTool[$k];
			$curk->[9] .= $exT[$i][9]; #--备注相加,  remark=$exT[$i][9]
			$curk->[6] += $exT[$i][6]; #--count=$exT[$i][6]
		}else{
			push @EMSTool,$exT[$i];
			$k ++;
		}
		$upTool{$tnum} ++;

	} 

	#$self->PAUSE("====111111");

	my $fileOut = $self->{JOB_PATH}."/user/$self->{Job}_${pnlStep}_${layer}.log";
	open  MY_FILE, ">:encoding(utf8)",$fileOut or die "$!";
	print MY_FILE "$lineTxt";
	close MY_FILE;	
	
	#---上传需获取板的层数
	$self->get_layers_count;
	my $lay_count =  $self->{lay_count}{signal};

    #--上传需获取钻孔的贯穿开始层，结束层次
	my ($throuLayStart,$throuLayEnd) = $self->get_drill_throu_star_end_layer_number($layer);

	#$self->PAUSE("$layer ==>$lay_count===$throuLayStart,$throuLayEnd");
    
	#---上传钻孔表到 MES 系统
	$self->UpLoadDrillInfoToMes($lay_count,$layer,$throuLayStart,$throuLayEnd,$holeMinSize,\@EMSTool);

	#$self->PAUSE("$layer ==>$lay_count===$throuLayStart,$throuLayEnd");
}

#--上传需获取钻孔的贯穿层次
sub get_drill_throu_star_end_layer_number{
	my $self           = shift;
	my $drillLay       = shift;
	my $matrix         = $self->{matrix};

	my $drlStarLay     = $matrix->{$drillLay}{drl_start};#--获取开始层
	my $drlEndLay      = $matrix->{$drillLay}{drl_end};#--获取结束层

	my $drlStarRow     = $matrix->{$drlStarLay}{row};#--获取开始层 所在的 row
	my $drlEndRow      = $matrix->{$drlEndLay}{row};#--获取结束层  所在的 row
    
	my $throuLayStart = 0;#--穿过第一层
	my $throuLayEnd   = 0;#--穿过最后一层
	my $layerOrd = 0;
	foreach my $layer (sort {$matrix->{$a}{row} <=> $matrix->{$b}{row}} keys %$matrix) {
			if ($matrix->{$layer}{side} =~ /top|bottom|inner/ && $matrix->{$layer}{layer_type} =~ /signal|power_ground|mixed/i) {
			    $layerOrd ++;
				if ($matrix->{$layer}{row} >= $drlStarRow && $throuLayStart == 0) {
				    $throuLayStart =  $layerOrd;
                }
				elsif ($matrix->{$layer}{row} <= $drlEndRow) {
					$throuLayEnd = $layerOrd;
                }
			}
	} 
	if ($throuLayStart == 0 && $throuLayEnd == 0) {
		if ($drillLay =~ /(\d\d)(\d\d)/) {
			my ($throuLayStart,$throuLayEnd) = ($1,$2);
		}elsif ($drillLay =~ /(\d)(\d\d)/) {
			my ($throuLayStart,$throuLayEnd) = ($1,$2);
		}elsif ($drillLay =~ /(\d)(\d)/) {
			my ($throuLayStart,$throuLayEnd) = ($1,$2);
		}
	}
	return $throuLayStart,$throuLayEnd; 
}








sub get_size_to_t{
	my $self = shift;
	my $drlFile = shift;
	my %tslot;
	my $lines = $self->ReadFile($drlFile);
	foreach my $line (@{$lines}) {
		if ($line =~ /(T\d{2})C(\S+)/) {
			my ($t,$size) = ($1,$2);
			$tslot{$size} = $t;
		}
	}
	#print Dumper \%tslot;
	return \%tslot;
}



#-----计算拼板内各step个数
sub get_allsteps{
	my $self  = shift;
	my ($job,$step,$stepCount) = @_;
	$self->INFO(entity_type=>"step",
			 entity_path=>"$job/$step",
			 data_type  =>"REPEAT",
	         parameters => "step");
	my @allstep = @{$self->{doinfo}{gREPEATstep}};
	foreach my $step1 (@allstep) {
		$stepCount->{$step1}++;
		$self->get_step_repeat($job,$step1,$stepCount);
	}
}



#--获取某一层钻孔信息
sub get_layer_holes_info{
	my $self = shift;
	my ($ha,$step,$layer,$stepCountP) = @_;

	$self->COM("config_edit,name=edt_edge2edge_slot_length,value=no,mode=user");
	$self->INFO(units => 'mm', entity_type => 'layer',
         entity_path => "$self->{Job}/$step/$layer",
         data_type => 'TOOL');
	#$self->COM("config_edit,name=edt_edge2edge_slot_length,value=$self->{edt_slot_config},mode=user");


	for my $i(0..$#{$self->{doinfo}{gTOOLdrill_size}}) {
		my $dz = $self->{doinfo}{gTOOLdrill_size}[$i]/1000;	
		my $fz = $self->{doinfo}{gTOOLfinish_size}[$i]/1000;
		$dz = sprintf("%0.3f",$dz);
		$fz = sprintf("%0.3f",$fz);
		my $tolMax = $self->{doinfo}{gTOOLmax_tol}[$i]/1000;
		my $tolMin = $self->{doinfo}{gTOOLmin_tol}[$i]/1000;
		my $type =  ($self->{doinfo}{gTOOLtype}[$i] =~ /non/i) ? "N" :"Y";
		my $type2 =  $self->{doinfo}{gTOOLtype2}[$i];
		my $long =  $self->{doinfo}{gTOOLslot_len}[$i];
		$long  = sprintf("%0.3f",$long/1000);
		my $count = $stepCountP->{$step}*$self->{doinfo}{gTOOLcount}[$i];   #---改数改为*以所有unit个数

		if ($tolMax == 0 && $tolMin==0) {             #-- 改为默认的
			if ($type =~ /Y/i) {
				$tolMax = "0.076";
				$tolMin = "0.076";
			}
			else {
				$tolMax = "0.05";
				$tolMin = "0.05";
			}
			if ($long > 0) {
				$tolMax = "0.10";
				$tolMin = "0.10";
			}
		}
		if ($fz==0) {
			$fz = $dz;
		}

		my $drillTimeOne = ($long>0) ?  $self->calc_hole_hits($long,$dz) : 0;
		my $drillTime  = $drillTimeOne * $count;
		push @{$ha->{$dz}{info}},[$fz,$type,$tolMax,$tolMin,$long,$step,$count,$drillTime,$type2];
	}
}





											






#===================================================================
#===================================================================
1;

