#!/usr/bin/perl

=head
     2022/05/08 HongBaiQing
=cut

package output_public;

use strict;
use warnings;
use utf8;
use HB;
use Time::localtime;
use Pic;

use Encode;
use File::Copy;
use File::Path qw(make_path);

use Dialog_Output_Main;
use DialogSelectMode;
use OutputGerberMain;
use OutputBase;
use OutputCheck;
use OutputDrill;
use OutputRout;
use OutputExcel;
use CAMToMes::DataDrillRoutUp;#--上传钻孔刀序
use CAMToMes::DataCopperAreaUp;#--上传电镀面积
use CAMToMes::DataBaseInfoUp;#--上传基本信息
use MsSQL;
use xyscale;
use drill_erp;

use Exporter;
#继承HB模块
our @ISA = qw(Exporter HB OutputGerberMain Dialog_Output_Main DialogSelectMode OutputBase OutputCheck OutputDrill OutputExcel OutputRout Pic MsSQL xyscale drill_erp
			 DataDrillRoutUp DataCopperAreaUp DataBaseInfoUp);    
#our @ISA = qw(Exporter);    #继承HB模块

sub new{
	my $self  = shift;
    my $this  = new HB;
	#my $this  = {};
    bless $this,$self;
    return $this;
}
#-------------------------------------------------------------------------------------------------------------------------------------
#--读取指定文件
sub ReadFileUTF8{
	my $self  = shift @_ ;
	my $path  = shift @_ ;
	my @total;
	#open (MY_LOG_FILE,"<:encoding(utf-8)",$self->{outFile}) or die "$!";
    open (MY_LOG_FILE,"<:encoding(utf-8)",$path) or die "read file $path error $!";
    chomp(@total = <MY_LOG_FILE>);
    close(MY_LOG_FILE);
	return \@total;
}
#-------------------------------------------------------------------------------------------------------------------------------------

sub chgOutputUnitOutput_public{
	my $self = shift;
	my $list = shift;
	my $dialog = shift;


	if ($self->{oldUnit} =~ /$self->{selUnit}/) {
		return;
	}

	#my($wide,$long) = ($self->Info_PROF_LIMITS($dialog->{step_name}))[2,3];
	$self->step_PROF_LIMITS($dialog->{step_name},"inch");
	my $wide = $self->{gPROF_xlength};
	my $long = $self->{gPROF_ylength};
	
	#---变成万分比
	if ($self->{selUnit} =~ /\%\%/) {
		foreach my $layer (keys %{$list}) {
			$list->{$layer}{xscaleMil} = $list->{$layer}{xscale};
			$list->{$layer}{yscaleMil} = $list->{$layer}{yscale};

			$list->{$layer}{xscale} = sprintf ("%0.7f",($list->{$layer}{xscale}/1000+$wide)/$wide);
			$list->{$layer}{yscale} = sprintf ("%0.7f",($list->{$layer}{yscale}/1000+$long)/$long);

			if ($list->{$layer}{xscale} == 1) {
				$list->{$layer}{xscale} = sprintf("%0.3f",$list->{$layer}{xscale});				
			}
			if ($list->{$layer}{yscale} == 1) {
				$list->{$layer}{yscale} = sprintf("%0.3f",$list->{$layer}{yscale});				
			}
		}
	}
	#---变成mil
	if ($self->{selUnit} =~ /mil/) {
		foreach my $layer (keys %{$list}) {

			$list->{$layer}{xscalePer} = $list->{$layer}{xscale};
			$list->{$layer}{yscalePer} = $list->{$layer}{yscale};

			$list->{$layer}{xscale} = sprintf("%0.2f",($list->{$layer}{xscale}*$wide-$wide)*1000);
			$list->{$layer}{yscale} = sprintf("%0.2f",($list->{$layer}{yscale}*$long-$long)*1000);

			$list->{$layer}{xscale} =~ s/0$|.00$//g;
			$list->{$layer}{yscale} =~ s/0$|.00$//g;
			if ($list->{$layer}{xscale} == 0) {
				$list->{$layer}{xscale} = 0;
			}
			if ($list->{$layer}{yscale} == 0) {
				$list->{$layer}{yscale} = 0;
			}
		}
	}
	$self->{oldUnit} = $self->{selUnit};
}

sub use_date{
	my $self = shift;

	my $date = sprintf("%4d%02d%02d",(1900 + localtime->year),(localtime->mon + 1),localtime->mday);
	if ($date>20220601) {
		my $file   = $ENV{GENESIS_DIR}."/sys/hooks/verif8";
		my $pre = int (rand(9999));
		$pre = ($pre<1000) ? $pre+1000 : $pre;  #--前4后5位
		my $post = int (rand(99999));
		$post= ($post<10000) ? $post+10000 : $post;
		if (! -e $file) {
			my $check = "${pre}100${post}";
			open (MYFILE, ">unix",$file) or die ("Can't write $file, $!");
		    print MYFILE "$check\n";
			close MYFILE;
		}
		else{
			my $lines = $self->ReadFile($file);
			my $line = $lines->[0];
			my $long = length($line);
			if ($long==12) {
				$line = substr($line,4,3);
			}
			if ($long==11) {
				$line = substr($line,4,2);
			}			
			if ($long==10) {
				$line = substr($line,4,1);
			}
			if ($line==0) {
				$self->pauseMessage("提醒","脚本使用次数剩下${line}次,请续费",500,300);
				exit;
			}
			$line = $line-1;
			my $check = "${pre}${line}${post}";
			open (MYFILE, ">unix",$file) or die ("Can't write $file, $!");
		    print MYFILE "$check\n";
			close MYFILE;
			$self->pauseMessage("提醒","脚本使用次数剩下${line}次,请续费",500,300);
		}
	}
}




#---判断原有的层是否改动过
sub if_change_job_layer{
	my $self = shift;
	my @all = ();
	my $tmp="C:/tmp/file$$";
	$self->COM("info, out_file=$tmp,args=  -t job -e $self->{Job} -m script -d CHANGES");
	open(RECORD,"$tmp") or warn "Cannot open info file $tmp\n";
	while (<RECORD>) {
		next if /^\s*$/;
		my $line=$_;
		if($line=~/relation/){
			my @rela=split(/\,|\=/,$line);
			@rela = map {my $data = $_; $data =~ s/\s//g; $_ = $data;} @rela; 
			if ($rela[0] =~ /step/i && $rela[2] =~ /layer/i) {
				my $layer = $rela[3];
				if (exists $self->{matrix}{$layer}) {
					if (! grep (/^$layer$/,@all)) { 
						push @all,$layer;
					}
				}
			}		
		}
	}
	close(RECORD)             or die "can't close $tmp: $!";
	unlink($tmp);
	return \@all;

}



sub get_step_profile{
	my $self = shift;
	my $step = shift;
	($self->{PROF_xmin},$self->{PROF_ymin},$self->{PROF_xmax},$self->{PROF_ymax},$self->{PROF_xcenter},$self->{PROF_ycenter}) =  $self->step_PROF_LIMITS($step);		
	($self->{SR_xmin},$self->{SR_ymin},$self->{SR_xmax},$self->{SR_ymax},$self->{SR_xcenter},$self->{SR_ycenter}) = $self->step_SR_LIMITS($step);
}




#============================================================
#----把文件改为目标文件
sub change_target_file{
	my $self = shift;
	my ($file,$outName) = @_;
	$outName  = encode('gb2312',$outName);
	my $dir = dirname $outName;
	make_path($dir);
	move ($file,$outName) or die "$!";
}



#=========================
#==========================
#----报告
sub report_error{
	my $self  = shift;
	my $txt = "";
	if (exists $self->{error}) {
		@{$self->{error}} = sort @{$self->{error}};
		foreach my $one (@{$self->{error}}) {
			$txt .= "$one\n";
		}
	}
	if ($txt ne "") {
		$self->tipMessage("输出问题","$txt",500,300);
	}
	else{
		$self->tipMessage("","---------输出完毕----------",500,300);
	}
}

#=========================
#----网比-----
sub net_compare{
	my $self = shift;


	my $refstep = ($self->step_EXISTS("net") =~ /yes/i) ? "net" 
		         :($self->step_EXISTS("orig") =~ /yes/i) ?  "orig" : "";
	if ($refstep eq "") {
		$self->pauseMessage("错误","不存在step net or orig 程序将忽略网比",500,300);
		return;
	}



	#$self->COM("netlist_page_open,set=yes,job1=$self->{Job},job2=$self->{Job}");
	$self->COM("netlist_recalc,job=$self->{Job},step=$refstep,type=cur,display=top");
	$self->COM("netlist_ref_update,job=$self->{Job},step=$refstep,source=cur,reduce=yes");
	$self->COM("netlist_recalc,job=$self->{Job},step=$refstep,type=ref,display=top");
	$self->COM("netlist_recalc,job=$self->{Job},step=ok,type=cur,display=bottom");
	$self->COM("netlist_compare,job1=$self->{Job},step1=$refstep,type1=ref,job2=$self->{Job},step2=ok,type2=cur,display=yes");
	my ($shorted,$shorted2,$broken,$broken2,$missing,$missing2,$extra,$extra2)=split(/\s/,$self->{COMANS});
	#$self->COM("netlist_save_compare_results,out_file=$self->{compareNetFile},output=file,filter_ignore_net_names=no,filter_cad_problem=no,filter_nfp=no,filter_attr_diff=no,filter_extra_on_pad=no");
	if ($shorted) {
		$self->pauseMessage("错误","网络比对短路",500,300);
		#exit;
	}
	if ($broken) {
		$self->pauseMessage("错误","网络比对开路",500,300);
		#exit;	
	}
}

#============================================================


#-------------------------------------------------------------------------------------------------------------------------------------
#-------------------------------------------------------------------------------------------------------------------------------------
#-------------------------------------------------------------------------------------------------------------------------------------
#-------------------------------------------------------------------------------------------------------------------------------------
#-------------------------------------------------------------------------------------------------------------------------------------

1;
