#!/usr/bin/perl


use strict;
use warnings;
use Data::Dumper;
use utf8;

use Exporter;
our @ISA = qw(Exporter);

sub new{
	my $self  = shift;
    my $this  = {};
    bless $this,$self;
    return $this;
}


my $self    = new main;

$self->{Job}   = $ENV{JOB};
$self->{Step}  = $ENV{STEP};
#---------变量说明---------------
#set run_cool  = 0        0为不跳钻1跳钻
#set cool_size = 40       跳钻孔最大是40mil
#set cool_dis  = 19.685   孔边到孔边的距小于19.685的跳钻
#set nibblemin = 354      大于354mil的孔做扩孔

my ($inFile,$outFile) = @ARGV;
my ($run_cool,$cool_size,$cool_dis,$nibblemin) = (1,40,19.685,354);


&main;
sub main{

	#----获取文件$1内容
	my $ha = &get_table_data;
    #---对T排序
	&order($ha);
	#print Dumper $ha;
	#----输出到$2
	&out_file($ha);

	#---输出报告
	&output_report($ha);
}

sub out_file{
	my $ha = shift;

	my $SPIN  = 0;
	my $FEED  = 0;
	my $cool_spead_h = -1;

	my $line = "";

	foreach my $i (sort {$a<=>$b} keys %{$ha->{table}}) {
		my $ord = $ha->{table}{$i}{order};
		my $TOOL_SIZE = $ha->{table}{$i}{ncSIZE};



		my $nc_size   = $TOOL_SIZE;
		my $DES = $ha->{table}{$i}{ncDESIGNATOR};	
		my $j = $i+1;

		$cool_spead_h = -1;
		#--设置跳钻
		if ($run_cool) {
			if ($TOOL_SIZE<=$cool_size) {
				$cool_spead_h = $TOOL_SIZE+$cool_dis;
			}
		}

		#---设置扩孔
		my $MODE =  "regular";
		my $machine = "machine";
		if ($TOOL_SIZE >= $nibblemin) {
			#$TOOL_SIZE = 125; #  扩孔刀径  3175mm
			$MODE = "nibble";
			# $machine = "sw";
			 $nc_size = 125;		
		}

		
		#----T01C3.2S300F85H5000
		#----T02C3.2S300F85H5000
		#----300与85为转速与下降速度5000为最大打孔数 
		if ($nc_size == 125.024) {
			$nc_size = 125.039;   # 把3.175.61 改为3.176
		}

		$line .= "$j $nc_size n $MODE 300 85 $machine 1 sep 5000 $j $TOOL_SIZE $ord $ord $cool_spead_h\n";
	}

    #print "$line\n";

	open (FILE,">$outFile") or die "$!";
	print FILE $line;
	close FILE;	
	#`cp $inFile C:/tmp/old1`;
	#`cp $outFile C:/tmp/old2`;
	#print Dumper $ha;
}

sub output_report{
	my $ha = shift;

	my $file = "C:/tmp/drill_rep";
	if (-e $file) {
		unlink $file;
	}

	my $line = "";
	foreach my $num (sort{$ha->{table}{$a}{order}<=>$ha->{table}{$b}{order}} keys %{$ha->{table}}) {
		$line .= "num==$num\;";
		foreach my $name (sort (keys %{$ha->{table}{$num}})) {
			$line .= "$name==$ha->{table}{$num}{$name};";
		}
		$line .="\n";
	}

	#my $jobPath = $self->get_job_path_per_dblist($self->{Job});
	#$file = $jobPath."/user/output".'-'.$self->{Step}.'-'.$self->{ncLAYER};
    open  MY_FILE, ">$file" or die "$!";
	print MY_FILE "$line";
	close MY_FILE;
}









sub order{
	my $ha = shift;
	my @all = ();  #圆孔
	my @slots = ();  #--条孔
	my %hh;
	my %hs;

	foreach my $i ( keys %{$ha->{table}}) {
		my $drlSizeMM = $ha->{table}{$i}{drlSizeMM};
		my $ncShape = $ha->{table}{$i}{ncSHAPE};
		if ($ncShape =~ /hole|text/) {
			if (! exists $hh{$drlSizeMM}) {
				$hh{$drlSizeMM}++;
				push @all,[$drlSizeMM,"hole"];
			}
		}
		if ($ncShape =~ /slot/i) {
			if (! exists $hs{$drlSizeMM}) {
				$hs{$drlSizeMM}++;
				push @slots,[$drlSizeMM,"slot"];
			}
		}
	}



	#================================================ 
	#---------如需排序,只需对@all排序即可
	my @one = ();
	my @two = ();
	my @three = ();
	my @normal = ();
	my @seven = ();

	for my $P (@all) {
		if ($P->[0] =~ /2051/) {
			push @one,[@{$P}];
		}
		elsif ($P->[0] =~ /3175/) {
			push @two,[@{$P}];
		}
		elsif ($P->[0] =~ /503/) {
			push @three,[@{$P}];
		}
		elsif ($P->[0] =~ /508/) {
			push @seven,[@{$P}];
		}
		else{
			push @normal,[@{$P}];
		}
	}
	@one = sort { $a->[0] <=> $b->[0]} @one;
	@two = sort { $a->[0] <=> $b->[0]} @two;
	@three = sort { $a->[0] <=> $b->[0]} @three;						
	@normal = sort { $a->[0] <=> $b->[0]} @normal;
	@slots = sort { $a->[0] <=> $b->[0]} @slots;
	@seven = sort { $a->[0] <=> $b->[0]} @seven;
	@all = (@one,@two,@three,@normal,@slots,@seven);

	#print Dumper \@all;

	
	#===================================================	
	foreach my $i ( keys %{$ha->{table}}) {
		my $drlSizeMM = $ha->{table}{$i}{drlSizeMM};
		for my $n (0..$#all) {
			my $type = $ha->{table}{$i}{ncSHAPE};
			if ($type =~ /text/i) {
				$type = "hole";
			}
			if ($all[$n][0] == $drlSizeMM && $all[$n][1] eq $type ) {
				my $j = $n+1;
				$ha->{table}{$i}{order} = $j
			}
		}
	}
	#print Dumper $ha;
}


sub get_table_data{
	my $ha = {};
	open (FILE,$inFile) or die "$!";
	while (<FILE>) {
		chomp;
		my $line = $_;
		$line =~ s/\'//g;
		if ($line =~ /set\s+(ncLAYER|ncSET|ncMACHINE|ncTHICKNESS)\s+=\s+\((.*)\)/) {
			my ($one,$two) = ($1,$2);
			$ha->{$one} = $two;		
			$self->{$one} = $two;	
		}
		#elsif ($line =~ /set\s+(ncSHAPE|ncTYPE|ncSIZE|ncTOUCH_COPPER|ncFLAG|ncCOUNT|ncSLOTLEN|ncPLUS_TOL|ncMINUS_TOL|ncFINISH_SIZE|ncDESIGNATOR)\s+=\s+\((.*)\)/) {
		elsif ($line =~ /set\s+(ncSHAPE|ncTYPE|ncSIZE|ncTOUCH_COPPER|ncFLAG|ncCOUNT|ncSLOTLEN|ncPLUS_TOL|ncMINUS_TOL|ncFINISH_SIZE|ncDESIGNATOR)\s+=\s+\((.*)\)/) {
			my ($one,$two) =($1,$2);
			my @all     = split /\s+/,$two;
			for (my $i=0; $i<=$#all; $i++) {
				$ha->{table}{$i}{$one} = $all[$i];
				if ($one =~ /ncSIZE/i) {
					my $size = sprintf("%.0f",$all[$i] * 25.4);
					$ha->{table}{$i}{drlSizeMM} = $size;
				}
			}
		}
	}
	close FILE;
	return $ha;
}


=head
$2 输出文件
echo $COUNT $TLSZ n regular $SPIN $FEED machine 1 sep $HITS $COUNT $TLSZ $ORD $ORD $cool >> $out_file
1 125 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
2 98 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
3 80.709 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
4 74.8 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
5 59.06 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
6 51.18 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
7 43.31 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
8 39.37 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
9 35.43 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
10 31.5 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
11 28 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
12 23.74 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
12 23.74 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
13 20 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1


$1 输入文件
set ncLAYER = ('drl' )
set ncSET = ('11' )
set ncMACHINE = ('excellon' )
set ncTHICKNESS = ('0' )
set ncSHAPE        = ('hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    )
set ncTYPE         = ('Via'     'Via'     'Via'     'Nplate'  'Nplate'  'Plate'   'Nplate'  'Nplate'  'Plate'   'Nplate'  'Plate'   'Nplate'  'Plate'   'Plate'   'Plate'   )
set ncSIZE         = ('11.811'  '11.89'   '17.717'  '31.496'  '39.37'   '41.339'  '51.181'  '62.992'  '80.709'  '90.551'  '100.394' '122.047' '124.803' '125.984' '129.921' )
set ncTOUCH_COPPER = ('no'      'no'      'no'      'no'      'no'      'no'      'no'      'no'      'no'      'no'      'no'      'no'      'no'      'no'      'no'      )
set ncFLAG         = ('0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       )
set ncCOUNT        = ('1040'    '20'      '20'      '10'      '20'      '5'       '20'      '20'      '4'       '20'      '13'      '4'       '11'      '2'       '4'       )
set ncSLOTLEN      = ('0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       )
set ncPLUS_TOL     = ('0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       )
set ncMINUS_TOL    = ('0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       )
set ncFINISH_SIZE  = ('11.811'  '11.89'   '17.717'  '-1'      '35.433'  '-1'      '47.244'  '-1'      '-1'      '86.614'  '-1'      '118.11'  '-1'      '-1'      '-1'      )
set ncDESIGNATOR   = ('0.40'    '.emp'    '.emp'    '.emp'    '0.95'    '.emp'    '1.25'    '.emp'    '.emp'    '2.25'    '.emp'    '.emp'    '.emp'    '.emp'    '.emp'    )
=cut


#--获取 data base 路径
sub getDBplistPath{
	my $self       = shift;
	my $dblistFile = $ENV{'GENESIS_DIR'} . "/sys/dblist";
	my %dblist;
	$self->{dblistnumber} = 0;
	if (-e $dblistFile) {
		my ($name,$path);
		open (MY_OPEN_MATRIX,$dblistFile) or die "can not open $dblistFile error: $!";
		while (<MY_OPEN_MATRIX>) {
				chomp;
				my $line = $_;
                if ($line =~ /NAME\=(\S+)/) {
					$name = $1;
                }
				elsif ($line =~ /PATH\=(\S+)/) {
					$path = $1;
					$self->{dblistnumber} ++;
					my $num = $self->{dblistnumber};
					$dblist{$num}{name} = $name;
					$dblist{$num}{path} = $path;
					#print "$num $name $path\n";
                }
		}
		close(MY_OPEN_MATRIX);
	}
	$self->{dblist} = \%dblist;
}

#--获取 data base 路径
sub getJobDBname{
	my $self       = shift;
	my $jobName    = shift;
	my $dblistFile = $ENV{'GENESIS_DIR'} . "/share/joblist";

	#print "getJobDBname $jobName start\n";
	my ($dbname,$jobMatchName);
	if (-e $dblistFile) {
		open (MY_OPEN_MATRIX,$dblistFile) or die "can not open $dblistFile error: $!";
		while (<MY_OPEN_MATRIX>) {
				chomp;
				my $line = $_;
				#print "$line\n";
                if ($line =~ /NAME\=($jobName)$/i) {
					$jobMatchName = $1;
                }
				if (! defined($jobMatchName)) {
					next;
				}
				if ($line =~ /DB\=(\S+)/) {
					$dbname = $1;
					#print "$dbname $line\n";
					last;
                }
		}
		close(MY_OPEN_MATRIX);
	}
	#print "getJobDBname $dblistFile ==>$jobName $dbname\n";
	return $dbname;
}

sub get_job_path_per_dblist{
	my $self	= shift @_;
	my $job     = shift @_;
	if (! exists $self->{dblistnumber}) {
		$self->getDBplistPath();
	}
	if ($self->{dblistnumber} == 1) {
		$self->{job_path}   = $self->{dblist}{1}{path}."/jobs/".$job;
	}elsif ($self->{dblistnumber} > 1) {
	    my $dbName = $self->getJobDBname($job);
		foreach my $num (keys %{$self->{dblist}}) {
			if ($self->{dblist}{$num}{name} eq $dbName) {
				print "$num eq $dbName\n";
				$self->{job_path}   = $self->{dblist}{$num}{path}."/jobs/".$job;
			}
		}
	}else{
		print "can not get job path";
		exit;
	}
	#print "$self->{job_path}\n";
	return $self->{job_path};
}
