#!/usr/bin/perl


use strict;
use warnings;
use Data::Dumper;
use utf8;


#---------变量说明---------------
#set run_cool  = 0        0为不跳钻1跳钻
#set cool_size = 40       跳钻孔最大是40mil
#set cool_dis  = 19.685   孔边到孔边的距小于19.685的跳钻
#set nibblemin = 354      大于354mil的孔做扩孔

my ($inFile,$outFile,$JOB) = @ARGV;
my ($run_cool,$cool_size,$cool_dis,$nibblemin) = (0,40,19.685,354);

my $layerCount = substr($JOB,5,2);


&main;
sub main{

	#----获取文件$1内容
	my $ha = &get_table_data;
	#print Dumper $ha;
    #---对T排序
	&order($ha);
	#print Dumper $ha;
	#----输出到$2
	&out_file($ha);
}

sub out_file{
	my $ha = shift;

	my $SPIN  = 0;
	my $FEED  = 0;
	my $cool_spead_h = -1;

	my $line = "";

	foreach my $i (sort {$a<=>$b} keys %{$ha->{table}}) {
		my $ord = $ha->{table}{$i}{order};
		my $TOOL_SIZE = $ha->{table}{$i}{ncSIZE};

		#if ($TOOL_SIZE == 125.945 && $layerCount == 2 ) { #---把双面板的3.199改为3.200
			#$TOOL_SIZE = 125.984;
		#}

		my $nc_size   = $TOOL_SIZE;
		my $DES = $ha->{table}{$i}{ncDESIGNATOR};	
		my $j = $i+1;


		#--设置跳钻
		if ($run_cool) {
			if ($TOOL_SIZE<=$cool_size) {
				$cool_spead_h = $TOOL_SIZE+$cool_dis;
			}
		}

		#---设置扩孔
		my $MODE =  "regular";
		my $machine = "machine";
		if ($TOOL_SIZE >= $nibblemin) {
			$TOOL_SIZE = 125; #  扩孔刀径  3175mm
			$MODE = "nibble";
			 $machine = "sw";
			
		}
		
		#----T01C3.2S300F85H5000
		#----T02C3.2S300F85H5000
		#----300与85为转速与下降速度5000为最大打孔数 
		$line .= "$j $nc_size n $MODE 300 85 $machine 1 sep 5000 $j $TOOL_SIZE $ord $ord $cool_spead_h\n";
	}

    print "$line\n";

	open (FILE,">$outFile") or die "$!";
	print FILE $line;
	close FILE;	
	`cp $outFile C:/tmp/old`;
}


sub order{
	my $ha = shift;
	my @all = ();
	foreach my $i ( keys %{$ha->{table}}) {
		my $drlSizeMM = $ha->{table}{$i}{drlSizeMM};
		if (! grep /^$drlSizeMM$/,@all) {
			push @all,$drlSizeMM;
		}
	}
	@all = sort {$a<=>$b} @all;

	#================================================ 
	#---------如需排序,只需对@all排序即可
	my @zero = ();
	my @one = ();
	my @two = ();
	my @three = ();
	my @four = ();
	my @fourAfter = ();
	my @five = ();
	my @six = ();
	my @sixAfter1 = ();
	my @sixAfter2 = ();
	my @seven = ();
	my @eight = ();

    foreach my $size (@all) {
		if ($size =~ /^3199$/) { #--板边孔
			push @zero,$size;    #---双面板这个把排前面		
		}
		elsif ($size =~ /^3160$/) { #--板边孔
			push @one,$size;
		}
		elsif ($size =~ /^1030$/ ) { #--板边孔
			push @two,$size;
		}
		elsif ($size =~ /^3170$/ ) { #--板边孔
			push @three,$size;
		}

		elsif ($size =~ /^3175$/ ) {  #--扩孔
			push @five,$size;
		}
		elsif ($size =~ /5$|8$/ ) {  #--条孔
			push @six,$size;
		}
		elsif ($size =~ /4$/ ) {  #--异形槽
			push @sixAfter1,$size;
		}
		elsif ($size =~ /6$/ ) {  #--连槽
			push @sixAfter2,$size;
		}
		elsif ($size =~ /9$/ ) {  #--披锋孔
			push @seven,$size;
		}
		elsif ($size =~ /^490$/ ) {  #--型号孔
			push @eight,$size;
		}
		elsif ($size =~ /7$/ ) {  #--连孔 排在圆孔后面
			push @fourAfter,$size;
		}
		else{
			push @four,$size;   #--圆孔
		}
    }

	@zero = sort {$a<=>$b} @zero;
	@one = sort {$a<=>$b} @one;
	@two = sort {$a<=>$b} @two;
	@three = sort {$a<=>$b} @three;
	@four = sort {$a<=>$b}  @four;
	@fourAfter = sort {$a<=>$b}  @fourAfter;
	@five = sort {$a<=>$b} @five;
	@six = sort {$a<=>$b} @six;
	@sixAfter1 = sort {$a<=>$b} @sixAfter1;
	@sixAfter2 = sort {$a<=>$b} @sixAfter2;
	@seven = sort {$a<=>$b} @seven;
	@eight = sort {$a<=>$b} @eight;
	@all = (@zero,@one,@two,@three,@four,@fourAfter,@five,@six,@sixAfter1,@sixAfter2,@seven,@eight);
	#=================================================== 
	
	foreach my $i ( keys %{$ha->{table}}) {
		my $drlSizeMM = $ha->{table}{$i}{drlSizeMM};
		for my $n (0..$#all) {
			if ($all[$n] == $drlSizeMM) {
				my $j = $n+1;
				$ha->{table}{$i}{order} = $j
			}
		}
	}	
}


sub get_table_data{
	my $ha = {};
	open (FILE,$inFile) or die "$!";
	while (<FILE>) {
		chomp;
		my $line = $_;
		$line =~ s/\'//g;
		if ($line =~ /set\s+(ncLAYER|ncSET|ncMACHINE|ncTHICKNESS)\s+=\s+\((.*)\)/) {
			my ($one,$two) = ($1,$2);
			$ha->{$one} = $two;		
		}
		elsif ($line =~ /set\s+(ncSHAPE|ncTYPE|ncSIZE|ncTOUCH_COPPER|ncFLAG|ncCOUNT|ncSLOTLEN|ncPLUS_TOL|ncMINUS_TOL|ncFINISH_SIZE|ncDESIGNATOR)\s+=\s+\((.*)\)/) {
			my ($one,$two) =($1,$2);
			my @all     = split /\s+/,$two;
			for (my $i=0; $i<=$#all; $i++) {
				$ha->{table}{$i}{$one} = $all[$i];
				if ($one =~ /ncSIZE/i) {
					my $size = sprintf("%.0f",$all[$i] * 25.4);
					$ha->{table}{$i}{drlSizeMM} = $size;
				}
			}
		}
	}
	close FILE;	
	return $ha;
}


=head
$2 输出文件
echo $COUNT $TLSZ n regular $SPIN $FEED machine 1 sep $HITS $COUNT $TLSZ $ORD $ORD $cool >> $out_file
1 125 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
2 98 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
3 80.709 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
4 74.8 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
5 59.06 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
6 51.18 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
7 43.31 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
8 39.37 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
9 35.43 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
10 31.5 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
11 28 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
12 23.74 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
12 23.74 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1
13 20 n regular 300 85 machine 1 sep 5000 .emp 0 0 0 -1


$1 输入文件
set ncLAYER = ('drl' )
set ncSET = ('11' )
set ncMACHINE = ('excellon' )
set ncTHICKNESS = ('0' )
set ncSHAPE        = ('hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    'hole'    )
set ncTYPE         = ('Via'     'Via'     'Via'     'Nplate'  'Nplate'  'Plate'   'Nplate'  'Nplate'  'Plate'   'Nplate'  'Plate'   'Nplate'  'Plate'   'Plate'   'Plate'   )
set ncSIZE         = ('11.811'  '11.89'   '17.717'  '31.496'  '39.37'   '41.339'  '51.181'  '62.992'  '80.709'  '90.551'  '100.394' '122.047' '124.803' '125.984' '129.921' )
set ncTOUCH_COPPER = ('no'      'no'      'no'      'no'      'no'      'no'      'no'      'no'      'no'      'no'      'no'      'no'      'no'      'no'      'no'      )
set ncFLAG         = ('0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       )
set ncCOUNT        = ('1040'    '20'      '20'      '10'      '20'      '5'       '20'      '20'      '4'       '20'      '13'      '4'       '11'      '2'       '4'       )
set ncSLOTLEN      = ('0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       )
set ncPLUS_TOL     = ('0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       )
set ncMINUS_TOL    = ('0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       '0'       )
set ncFINISH_SIZE  = ('11.811'  '11.89'   '17.717'  '-1'      '35.433'  '-1'      '47.244'  '-1'      '-1'      '86.614'  '-1'      '118.11'  '-1'      '-1'      '-1'      )
set ncDESIGNATOR   = ('0.40'    '.emp'    '.emp'    '.emp'    '0.95'    '.emp'    '1.25'    '.emp'    '.emp'    '2.25'    '.emp'    '.emp'    '.emp'    '.emp'    '.emp'    )
=cut



