#!/usr/bin/perl

=head
     01/29/16 HongBaiQing
=cut

package xyscale;

use strict;
use warnings;
use Encode;
use File::Basename;
use File::Copy;
use File::Path qw(make_path);
use utf8;
use Time::localtime;
use Data::Dumper;
#============================
##################################################################################
##################################################################################

sub set_xyscale_values{
	my $self = shift;
	my $jwdata = shift;
	my $cahr = abs($jwdata-$self->{PROF_xmax}*25.4);
	my $jw = ($cahr<1) ? "x" : "y";  #---纬向对应机内的是x还是y方向




	my ($culidlayersT,$culidlayersB) = $self->get_type_layers("culdi");
	foreach my $layer (@{$culidlayersT} ) {
		my $xinthk = $self->{matrix}{$layer}{xinthk};
		my $cuthk = $self->{matrix}{$layer}{cuthk};
		$self->get_ls_data($layer,$xinthk,$cuthk,$jw,$self->{xinMaterial},$self->{ppMaterial});
	}


	#---芯板厚度相差<0.3mm,各自的不变
	#---0.3mm<=芯板厚度差<0.5mm 薄芯板比例=厚芯板比例*50%+薄芯板比例*50% 按上取整数 1.1取2 0.9取1
	#---芯板厚度差>=0.5mm 薄芯板比例=厚芯板比例*60%+薄芯板比例*40%   按0.5一级取数 不到0.5取0.5 >0.5取1
	#----差值不超过2

	#--最高芯板的层的拉伸值

	my ($xinThkMax,$topLayerMax) = ($self->{allXinthk}[-1][0],$self->{allXinthk}[-1][1]);


	foreach my $layer (@{$culidlayersT} ) {
		my $xinthk = $self->{matrix}{$layer}{xinthk};
		my $anther = $self->{matrix}{$layer}{another};
		my $char = $xinThkMax-$xinthk;
		foreach my $one ("xscale","yscale") {
			my $scaleOld = $self->{matrix}{$layer}{$one};
			my $scaleMax = $self->{matrix}{$topLayerMax}{$one};

			if (0.3<$char && $char<0.5) {
				my $scaleNew = $scaleMax*0.5+$scaleOld*0.5;
				my $scaleInt = int $scaleNew;
				my $smallData = $scaleNew-$scaleInt;
				if ($smallData>0) {
					$scaleNew = $scaleInt+1;
				}

				#----差值不超过2
				if ($scaleNew-$scaleMax>2) {
					$scaleNew=$scaleMax+2;
				}
				if ($scaleMax-$scaleNew>2) {
					$scaleNew=$scaleMax-2;
				}
				$self->{matrix}{$layer}{$one} = $scaleNew;
				$self->{matrix}{$anther}{$one} = $scaleNew;

			}
			if ($char>=0.5) {
				my $scaleNew = $scaleMax*0.5+$scaleOld*0.5;
				my $scaleInt = int $scaleNew;
				my $smallData = $scaleNew-$scaleInt;
				if ($smallData>0.5) {
					$scaleNew = $scaleInt+1;
				}
				elsif ($smallData>0) {
					$scaleNew = $scaleInt+0.5;
				}

				#----差值不超过2
				if ($scaleNew-$scaleMax>2) {
					$scaleNew=$scaleMax+2;
				}
				if ($scaleMax-$scaleNew>2) {
					$scaleNew=$scaleMax-2;
				}
				$self->{matrix}{$layer}{$one} = $scaleNew;
				$self->{matrix}{$anther}{$one} = $scaleNew;

			}
		}
	}		
}


sub get_ls_data{
	my $self = shift;
	my ($layer,$xinthk,$cuthk,$jw,$xinMaterial,$ppMaterial) = @_;


	$self->{matrix}{$layer}{xscale}= '1.0000';
	$self->{matrix}{$layer}{yscale}= '1.0000';
	#--默认纬向是短边x

	#---不是这些板材的按S1141
	if ($xinMaterial !~ /S1141|KB-6160|KB6160|S1600|S1600L|KB6160|TU872
		|KB-6165F|KB6165F|KB-6167F|KB6167F|S1000H|S1000-2M|S1150G|S1165|S10002M|H150
		|IT180A|IT158|TU-768|TU768|TU-862HF|TU862HF|R5775G|TU-933i|TU933i|TU768|TU862|TU933i|TU-862T|TU862T|TU-865|TU865|R5775K|FR408HR|370HR|H175HF|H1170|IT968|IT968G
		|TU-883|TU883|S7439|S7439C|S7439G
		|TU-872SLK|TU872SLK/i) {  
		$xinMaterial = "S1141";
	}

	#---不是这些PP的按S2116
	if ($ppMaterial !~ /2116|1080|3313|7628|2116|1080|3313|7628/) {
		$ppMaterial = "2116";
	}

	#--有的内层写0.5 改为H
	if ($cuthk == 0.5) {
		$cuthk  = 'H';
	}



	if ($xinMaterial =~ /S1141|KB-6160|KB6160|S1600|S1600L|KB6160|TU872/i) {  #---取材材料时已去掉中杆 1
		#=============1
		if ( ($xinthk<=0.075 && $cuthk=~ /H/i) 
		 ||  ($xinthk<=0.06 && $cuthk == 1)) {
			if ($ppMaterial eq "2116" || $ppMaterial eq "1080" || $ppMaterial eq "3313") {
				$self->{matrix}{$layer}{xscale}= 1.0001;
				$self->{matrix}{$layer}{yscale}= 1.00075;
			}
			elsif ($ppMaterial =~ /7628/ && $ppMaterial =~ /2116|1080|3313/ ) {
				$self->{matrix}{$layer}{xscale}= 1.0002;
				$self->{matrix}{$layer}{yscale}= 1.00055;
			}
			elsif ($ppMaterial eq "7628" ) {
				$self->{matrix}{$layer}{xscale}= 1.0005;
				$self->{matrix}{$layer}{yscale}= 1.0004;
			}
		}
		#=============2
		elsif (($xinthk>0.075 && $xinthk<=0.11 && $cuthk=~ /H/i) 
			|| ($xinthk>0.06 && $xinthk<=0.11 && $cuthk== 1)) {
			if ($ppMaterial eq "2116" || $ppMaterial eq "1080" || $ppMaterial eq "3313") {
				$self->{matrix}{$layer}{xscale}= 1.0001;
				$self->{matrix}{$layer}{yscale}= 1.00065;
			}
			elsif ($ppMaterial =~ /7628/ && $ppMaterial =~ /2116|1080|3313/ ) {
				$self->{matrix}{$layer}{xscale}= 1.0002;
				$self->{matrix}{$layer}{yscale}= 1.00045;
			}
			elsif ($ppMaterial eq "7628" ) {
				$self->{matrix}{$layer}{xscale}= 1.00035;
				$self->{matrix}{$layer}{yscale}= 1.00045;
			}
		}
		#=============3
		elsif (($xinthk>0.11 && $xinthk<=0.13 && $cuthk=~ /H/i) 
			|| ($xinthk>0.11 && $xinthk<=0.13 && $cuthk== 1)) {
			if ($ppMaterial eq "2116" || $ppMaterial eq "1080" || $ppMaterial eq "3313") {
				$self->{matrix}{$layer}{xscale}= 1.0001;
				$self->{matrix}{$layer}{yscale}= 1.0006;
			}
			elsif ($ppMaterial =~ /7628/ && $ppMaterial =~ /2116|1080|3313/ ) {
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.0004;
			}
			elsif ($ppMaterial eq "7628" ) {
				$self->{matrix}{$layer}{xscale}= 1.0004;
				$self->{matrix}{$layer}{yscale}= 1.0003;
			}
		}
		#=============4
		elsif (($xinthk>0.13 && $xinthk<=0.145 && $cuthk=~ /H/i) 
			|| ($xinthk>0.13 && $xinthk<=0.15 && $cuthk== 1)) {
			if ($ppMaterial eq "2116" || $ppMaterial eq "1080" || $ppMaterial eq "3313") {
				$self->{matrix}{$layer}{xscale}= 1.0001;
				$self->{matrix}{$layer}{yscale}= 1.00055;
			}
			elsif ($ppMaterial =~ /7628/ && $ppMaterial =~ /2116|1080|3313/ ) {
				$self->{matrix}{$layer}{xscale}= 1.0001;
				$self->{matrix}{$layer}{yscale}= 1.00035;
			}
			elsif ($ppMaterial eq "7628" ) {
				$self->{matrix}{$layer}{xscale}= 1.00035;
				$self->{matrix}{$layer}{yscale}= 1.00025;
			}
		}
		#=============5
		elsif (($xinthk>0.145 && $xinthk<=0.165 && $cuthk=~ /H/i) 
			|| ($xinthk>0.15 && $xinthk<=0.17 && $cuthk== 1)) {
			if ($ppMaterial eq "2116" || $ppMaterial eq "1080" || $ppMaterial eq "3313") {
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.0005;
			}
			elsif ($ppMaterial =~ /7628/ && $ppMaterial =~ /2116|1080|3313/ ) {
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.0003;
			}
			elsif ($ppMaterial eq "7628" ) {
				$self->{matrix}{$layer}{xscale}= 1.0003;
				$self->{matrix}{$layer}{yscale}= 1.00025;
			}
		}
		#=============6
		elsif (($xinthk>0.165 && $xinthk<=0.23 && $cuthk=~ /H/i) 
			|| ($xinthk>0.17 && $xinthk<=0.22 && $cuthk== 1)) {
			if ($ppMaterial eq "2116" || $ppMaterial eq "1080" || $ppMaterial eq "3313") {
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.00045;
			}
			elsif ($ppMaterial =~ /7628/ && $ppMaterial =~ /2116|1080|3313/ ) {
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.00025;
			}
			elsif ($ppMaterial eq "7628" ) {
				$self->{matrix}{$layer}{xscale}= 1.0004;
				$self->{matrix}{$layer}{yscale}= 1.00025;
			}
		}
		#=============7
		elsif (($xinthk>0.23 && $xinthk<=0.265 && $cuthk=~ /H/i) 
			|| ($xinthk>0.22 && $xinthk<=0.27 && $cuthk== 1)) {
			if ($ppMaterial eq "2116" || $ppMaterial eq "1080" || $ppMaterial eq "3313") {
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.0004;
			}
			elsif ($ppMaterial =~ /7628/ && $ppMaterial =~ /2116|1080|3313/ ) {
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.0002;
			}
			elsif ($ppMaterial eq "7628" ) {
				$self->{matrix}{$layer}{xscale}= 1.00035;
				$self->{matrix}{$layer}{yscale}= 1.0002;
			}
		}
		#=============8
		elsif (($xinthk>0.265 && $xinthk<=0.365 && $cuthk=~ /H/i) 
			|| ($xinthk>0.27 && $xinthk<=0.37 && $cuthk== 1)) {
			if ($ppMaterial eq "2116" || $ppMaterial eq "1080" || $ppMaterial eq "3313") {
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.0003;
			}
			elsif ($ppMaterial =~ /7628/ && $ppMaterial =~ /2116|1080|3313/ ) {
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.00015;
			}
			elsif ($ppMaterial eq "7628" ) {
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.0003;
			}
		}
		#=============9
		elsif (($xinthk>0.365 && $xinthk<=0.465 && $cuthk=~ /H/i) 
			|| ($xinthk>0.37 && $xinthk<=0.47 && $cuthk== 1)) {
			if ($ppMaterial eq "2116" || $ppMaterial eq "1080" || $ppMaterial eq "3313") {
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.0002;
			}
			elsif ($ppMaterial =~ /7628/ && $ppMaterial =~ /2116|1080|3313/ ) {
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.00015;
			}
			elsif ($ppMaterial eq "7628" ) {
				$self->{matrix}{$layer}{xscale}= 1.00025;
				$self->{matrix}{$layer}{yscale}= 1.00015;
			}
		}
		#=============10
		elsif (($xinthk>0.465 && $xinthk<=1.0 && $cuthk=~ /H/i) 
			|| ($xinthk>0.47 && $xinthk<=1.0 && $cuthk== 1)) {
			if ($ppMaterial eq "2116" || $ppMaterial eq "1080" || $ppMaterial eq "3313") {
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.00015;
			}
			elsif ($ppMaterial =~ /7628/ && $ppMaterial =~ /2116|1080|3313/ ) {
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.00015;
			}
			elsif ($ppMaterial eq "7628" ) {
				$self->{matrix}{$layer}{xscale}= 1.0002;
				$self->{matrix}{$layer}{yscale}= 1.00015;
			}
		}
		#=============11
		elsif (($xinthk>1.0 && $xinthk<=1.2 && $cuthk=~ /H/i) 
			|| ($xinthk>1.0 && $xinthk<=1.2 && $cuthk== 1)) {
			if ($self->{lay_count}{signal} == 4) {   #--4层板
				if ($ppMaterial eq "2116" || $ppMaterial eq "1080" || $ppMaterial eq "3313") {
					$self->{matrix}{$layer}{xscale}= 1.00015;
					$self->{matrix}{$layer}{yscale}= 1.00015;
				}
				elsif ($ppMaterial =~ /7628/ && $ppMaterial =~ /2116|1080|3313/ ) {
					$self->{matrix}{$layer}{xscale}= 1.00015;
					$self->{matrix}{$layer}{yscale}= 1.00015;
				}
				elsif ($ppMaterial eq "7628" ) {
					$self->{matrix}{$layer}{xscale}= 1.00015;
					$self->{matrix}{$layer}{yscale}= 1.00015;
				}
			}
		}

	}
	elsif ($xinMaterial =~ /KB-6165F|KB6165F|KB-6167F|KB6167F|S1000H|S1000-2M|S1150G|S1165|S10002M|H150/i) {     #---取材材料时已去掉中杆2
		
		#-----2-----------1
		if ( ($xinthk<=0.11 && $cuthk=~ /H/i) ||  ($xinthk<=0.11 && $cuthk == 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0005;
			$self->{matrix}{$layer}{yscale}= 1.0008;
		}
		#-----2-----------2
		elsif (($xinthk>0.11 && $xinthk<=0.13 && $cuthk=~ /H/i) 
			|| ($xinthk>0.11 && $xinthk<=0.13 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00045;
			$self->{matrix}{$layer}{yscale}= 1.00075;
		}
		#-----2-----------3
		elsif (($xinthk>0.13 && $xinthk<=0.145 && $cuthk=~ /H/i) 
			|| ($xinthk>0.13 && $xinthk<=0.15 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00045;
			$self->{matrix}{$layer}{yscale}= 1.0007;
		}
		#-----2-----------4
		elsif (($xinthk>0.145 && $xinthk<=0.165 && $cuthk=~ /H/i) 
			|| ($xinthk>0.15 && $xinthk<=0.17 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0004;
			$self->{matrix}{$layer}{yscale}= 1.0007;
		}
		#-----2-----------5
		elsif (($xinthk>0.165 && $xinthk<=0.23 && $cuthk=~ /H/i) 
			|| ($xinthk>0.17 && $xinthk<=0.22 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00035;
			$self->{matrix}{$layer}{yscale}= 1.00065;
		}
		#-----2-----------6
		elsif (($xinthk>0.23 && $xinthk<=0.265 && $cuthk=~ /H/i) 
			|| ($xinthk>0.22 && $xinthk<=0.27 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0003;
			$self->{matrix}{$layer}{yscale}= 1.00055;
		}
		#-----2-----------7
		elsif (($xinthk>0.265 && $xinthk<=0.365 && $cuthk=~ /H/i) 
			|| ($xinthk>0.27 && $xinthk<=0.27 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00025;
			$self->{matrix}{$layer}{yscale}= 1.0005;
		}
		#-----2-----------8
		elsif (($xinthk>0.365 && $xinthk<=0.465 && $cuthk=~ /H/i) 
			|| ($xinthk>0.37 && $xinthk<=0.47 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0002;
			$self->{matrix}{$layer}{yscale}= 1.0004;
		}
		#-----2-----------9
		elsif (($xinthk>0.465 && $xinthk<=1.0 && $cuthk=~ /H/i) 
			|| ($xinthk>0.47 && $xinthk<=1.0 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0002;
			$self->{matrix}{$layer}{yscale}= 1.0003;
		}
		#-----2-----------10
		elsif (($xinthk>1.0 && $xinthk<=1.2 && $cuthk=~ /H/i) 
			|| ($xinthk>1.0 && $xinthk<=1.2 && $cuthk== 1)) {
			if ($self->{lay_count}{signal} == 4) {   #--4层板
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.00015;
			}
		}
	}

	elsif ($xinMaterial =~ /IT180A|IT158|TU-768|TU768|TU-862HF|TU862HF|R5775G|TU-933i|TU933i|TU768|TU862|TU933i|TU-862T|TU862T|TU-865|TU865|R5775K|FR408HR|370HR|H175HF|H1170|IT968|IT968G/) {   #---取材材料时已去掉中杆3
		#-----3-----------1
		if ( ($xinthk<=0.11 && $cuthk=~ /H/i) ||  ($xinthk<=0.11 && $cuthk == 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00045;
			$self->{matrix}{$layer}{yscale}= 1.0008;
		}
		#-----3----------2
		elsif (($xinthk>0.11 && $xinthk<=0.13 && $cuthk=~ /H/i) 
			|| ($xinthk>0.11 && $xinthk<=0.13 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0004;
			$self->{matrix}{$layer}{yscale}= 1.00075;
		}
		#-----3-----------3
		elsif (($xinthk>0.13 && $xinthk<=0.145 && $cuthk=~ /H/i) 
			|| ($xinthk>0.13 && $xinthk<=0.15 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0004;
			$self->{matrix}{$layer}{yscale}= 1.0007;
		}
		#-----3-----------4
		elsif (($xinthk>0.145 && $xinthk<=0.165 && $cuthk=~ /H/i) 
			|| ($xinthk>0.15 && $xinthk<=0.17 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00035;
			$self->{matrix}{$layer}{yscale}= 1.00065;
		}
		#-----3-----------5
		elsif (($xinthk>0.165 && $xinthk<=0.23 && $cuthk=~ /H/i) 
			|| ($xinthk>0.17 && $xinthk<=0.22 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00035;
			$self->{matrix}{$layer}{yscale}= 1.0006;
		}
		#-----3-----------6
		elsif (($xinthk>0.23 && $xinthk<=0.265 && $cuthk=~ /H/i) 
			|| ($xinthk>0.22 && $xinthk<=0.27 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00003;
			$self->{matrix}{$layer}{yscale}= 1.000055;
		}
		#-----3-----------7
		elsif (($xinthk>0.265 && $xinthk<=0.365 && $cuthk=~ /H/i) 
			|| ($xinthk>0.27 && $xinthk<=0.27 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0003;
			$self->{matrix}{$layer}{yscale}= 1.00045;
		}
		#-----3-----------8
		elsif (($xinthk>0.365 && $xinthk<=0.465 && $cuthk=~ /H/i) 
			|| ($xinthk>0.37 && $xinthk<=0.47 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00025;
			$self->{matrix}{$layer}{yscale}= 1.0004;
		}
		#-----3-----------9
		elsif (($xinthk>0.465 && $xinthk<=1.0 && $cuthk=~ /H/i) 
			|| ($xinthk>0.47 && $xinthk<=1.0 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0002;
			$self->{matrix}{$layer}{yscale}= 1.00035;
		}
		#-----3----------10
		elsif (($xinthk>1.0 && $xinthk<=1.2 && $cuthk=~ /H/i) 
			|| ($xinthk>1.0 && $xinthk<=1.2 && $cuthk== 1)) {
			if ($self->{lay_count}{signal} == 4) {   #--4层板
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.00015;
			}
		}
	}
	elsif ($xinMaterial =~ /TU-883|TU883|S7439|S7439C|S7439G/i) {  #---取材材料时已去掉中杆4
		#-----4-----------1
		if ( ($xinthk<=0.11 && $cuthk=~ /H/i) ||  ($xinthk<=0.11 && $cuthk == 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0008;
			$self->{matrix}{$layer}{yscale}= 1.0008;
		}
		#-----4----------2
		elsif (($xinthk>0.11 && $xinthk<=0.13 && $cuthk=~ /H/i) 
			|| ($xinthk>0.11 && $xinthk<=0.13 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0006;
			$self->{matrix}{$layer}{yscale}= 1.00075;
		}
		#-----4-----------3
		elsif (($xinthk>0.13 && $xinthk<=0.145 && $cuthk=~ /H/i) 
			|| ($xinthk>0.13 && $xinthk<=0.15 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0004;
			$self->{matrix}{$layer}{yscale}= 1.0007;
		}
		#-----4-----------4
		elsif (($xinthk>0.145 && $xinthk<=0.165 && $cuthk=~ /H/i) 
			|| ($xinthk>0.15 && $xinthk<=0.17 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00035;
			$self->{matrix}{$layer}{yscale}= 1.00065;
		}
		#-----4-----------5
		elsif (($xinthk>0.165 && $xinthk<=0.23 && $cuthk=~ /H/i) 
			|| ($xinthk>0.17 && $xinthk<=0.22 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00035;
			$self->{matrix}{$layer}{yscale}= 1.0006;
		}
		#-----4-----------6
		elsif (($xinthk>0.23 && $xinthk<=0.265 && $cuthk=~ /H/i) 
			|| ($xinthk>0.22 && $xinthk<=0.27 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0003;
			$self->{matrix}{$layer}{yscale}= 1.00055;
		}
		#-----4-----------7
		elsif (($xinthk>0.265 && $xinthk<=0.365 && $cuthk=~ /H/i) 
			|| ($xinthk>0.27 && $xinthk<=0.37 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0003;
			$self->{matrix}{$layer}{yscale}= 1.00045;
		}
		#-----4-----------8
		elsif (($xinthk>0.365 && $xinthk<=0.465 && $cuthk=~ /H/i) 
			|| ($xinthk>0.37 && $xinthk<=0.47 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00025;
			$self->{matrix}{$layer}{yscale}= 1.0004;
		}
		#-----4-----------9
		elsif (($xinthk>0.465 && $xinthk<=1.0 && $cuthk=~ /H/i) 
			|| ($xinthk>0.47 && $xinthk<=1.0 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0002;
			$self->{matrix}{$layer}{yscale}= 1.00035;
		}
		#-----4-----------10
		elsif (($xinthk>1.0 && $xinthk<=1.2 && $cuthk=~ /H/i) 
			|| ($xinthk>1.0 && $xinthk<=1.2 && $cuthk== 1)) {
			if ($self->{lay_count}{signal} == 4) {   #--4层板
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.00015;
			}
		}
	}
	elsif ($xinMaterial =~ /TU-872SLK|TU872SLK/i) {        #---取材材料时已去掉中杆5
		#-----5-----------1
		if ( ($xinthk<=0.08 && $cuthk=~ /H/i) ||  ($xinthk<=0.08 && $cuthk == 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00055;
			$self->{matrix}{$layer}{yscale}= 1.0011;
		}
		#-----5----------2
		elsif (($xinthk>0.08 && $xinthk<=0.11 && $cuthk=~ /H/i) 
			|| ($xinthk>0.11 && $xinthk<=0.11 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0005;
			$self->{matrix}{$layer}{yscale}= 1.0010;
		}
		#-----5-----------3
		elsif (($xinthk>0.11 && $xinthk<=0.13 && $cuthk=~ /H/i) 
			|| ($xinthk>0.11 && $xinthk<=0.13 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0003;
			$self->{matrix}{$layer}{yscale}= 1.0008;
		}
		#-----5-----------4
		elsif (($xinthk>0.13 && $xinthk<=0.15 && $cuthk=~ /H/i) 
			|| ($xinthk>0.13 && $xinthk<=0.15 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.0003;
			$self->{matrix}{$layer}{yscale}= 1.0007;
		}
		#-----5-----------5
		elsif (($xinthk>0.15 && $xinthk<=0.18 && $cuthk=~ /H/i) 
			|| ($xinthk>0.15 && $xinthk<=0.18 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00015;
			$self->{matrix}{$layer}{yscale}= 1.0005;
		}
		#-----5-----------6
		elsif (($xinthk>0.18 && $xinthk<=0.25 && $cuthk=~ /H/i) 
			|| ($xinthk>0.18 && $xinthk<=0.25 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00015;
			$self->{matrix}{$layer}{yscale}= 1.00045;
		}
		#-----5-----------7
		elsif (($xinthk>0.25 && $xinthk<=0.38 && $cuthk=~ /H/i) 
			|| ($xinthk>0.25 && $xinthk<=0.38 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00015;
			$self->{matrix}{$layer}{yscale}= 1.0004;
		}
		#-----5-----------8
		elsif (($xinthk>0.38 && $xinthk<=0.61 && $cuthk=~ /H/i) 
			|| ($xinthk>0.38 && $xinthk<=0.61 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00015;
			$self->{matrix}{$layer}{yscale}= 1.0002;
		}
		#-----5-----------9
		elsif (($xinthk>0.61 && $xinthk<=1.0 && $cuthk=~ /H/i) 
			|| ($xinthk>0.61 && $xinthk<=1.0 && $cuthk== 1)) {
			$self->{matrix}{$layer}{xscale}= 1.00015;
			$self->{matrix}{$layer}{yscale}= 1.00015;
		}
		#-----5-----------10
		elsif (($xinthk>1.0 && $xinthk<=1.2 && $cuthk=~ /H/i) 
			|| ($xinthk>1.0 && $xinthk<=1.2 && $cuthk== 1)) {
			if ($self->{lay_count}{signal} == 4) {   #--4层板
				$self->{matrix}{$layer}{xscale}= 1.00015;
				$self->{matrix}{$layer}{yscale}= 1.00015;
			}
		}
	}

	#---厚铜
	#----6---1----
	if ($xinthk<=0.075) {
		if ($cuthk == 2) {
			$self->{matrix}{$layer}{xscale}= 1.0008;
			$self->{matrix}{$layer}{yscale}= 1.0011;
		}
		elsif ($cuthk == 3) {
			$self->{matrix}{$layer}{xscale}= 1.0009;
			$self->{matrix}{$layer}{yscale}= 1.0013;
		}
		elsif ($cuthk >=4) {
			$self->{matrix}{$layer}{xscale}= 1.0010;
			$self->{matrix}{$layer}{yscale}= 1.0014;
		}
	}
	#----6---2----
	elsif ($xinthk>0.075 && $xinthk<=0.11) {
		if ($cuthk == 2) {
			$self->{matrix}{$layer}{xscale}= 1.00055;
			$self->{matrix}{$layer}{yscale}= 1.0008;
		}
		elsif ($cuthk == 3) {
			$self->{matrix}{$layer}{xscale}= 1.0006;
			$self->{matrix}{$layer}{yscale}= 1.0010;
		}
		elsif ($cuthk >=4) {
			$self->{matrix}{$layer}{xscale}= 1.00065;
			$self->{matrix}{$layer}{yscale}= 1.0010;
		}
	}
	#----6---3----
	elsif ($xinthk>0.11 && $xinthk<=0.15) {
		if ($cuthk == 2) {
			$self->{matrix}{$layer}{xscale}= 1.00045;
			$self->{matrix}{$layer}{yscale}= 1.00065;
		}
		elsif ($cuthk == 3) {
			$self->{matrix}{$layer}{xscale}= 1.00045;
			$self->{matrix}{$layer}{yscale}= 1.0007;
		}
		elsif ($cuthk >=4) {
			$self->{matrix}{$layer}{xscale}= 1.00045;
			$self->{matrix}{$layer}{yscale}= 1.0007;
		}
	}
	#----6---4----
	elsif ($xinthk>0.15 && $xinthk<=0.2) {
		if ($cuthk == 2) {
			$self->{matrix}{$layer}{xscale}= 1.0003;
			$self->{matrix}{$layer}{yscale}= 1.0005;
		}
		elsif ($cuthk == 3) {
			$self->{matrix}{$layer}{xscale}= 1.00035;
			$self->{matrix}{$layer}{yscale}= 1.00045;
		}
		elsif ($cuthk >=4) {
			$self->{matrix}{$layer}{xscale}= 1.00025;
			$self->{matrix}{$layer}{yscale}= 1.0004;
		}
	}
	#----6---5----
	elsif ($xinthk>0.2 && $xinthk<=0.3) {
		if ($cuthk == 2) {
			$self->{matrix}{$layer}{xscale}= 1.0002;
			$self->{matrix}{$layer}{yscale}= 1.0004;
		}
		elsif ($cuthk == 3) {
			$self->{matrix}{$layer}{xscale}= 1.00025;
			$self->{matrix}{$layer}{yscale}= 1.00035;
		}
		elsif ($cuthk >=4) {
			$self->{matrix}{$layer}{xscale}= 1.0002;
			$self->{matrix}{$layer}{yscale}= 1.00035;
		}
	}
	#----6---6---
	elsif ($xinthk>0.3 && $xinthk<=1.2) {
		if ($cuthk == 2) {
			$self->{matrix}{$layer}{xscale}= 1.00015;
			$self->{matrix}{$layer}{yscale}= 1.0003;
		}
		elsif ($cuthk == 3) {
			$self->{matrix}{$layer}{xscale}= 1.00015;
			$self->{matrix}{$layer}{yscale}= 1.00025;
		}
		elsif ($cuthk >=4) {
			$self->{matrix}{$layer}{xscale}= 1.0001;
			$self->{matrix}{$layer}{yscale}= 1.00025;
		}
	}


	if ($jw =~ /y/i) {
		my $tmp = $self->{matrix}{$layer}{xscale};
		$self->{matrix}{$layer}{xscale} = $self->{matrix}{$layer}{yscale};
		$self->{matrix}{$layer}{yscale} = $tmp; 

	}
	my $anther = $self->{matrix}{$layer}{another};




	$self->{matrix}{$layer}{xscale} =  sprintf ("%0.2f",($self->{matrix}{$layer}{xscale} -1)*10000);
	$self->{matrix}{$layer}{yscale} =  sprintf ("%0.2f",($self->{matrix}{$layer}{yscale} -1)*10000);

	$self->{matrix}{$layer}{xscale} =~ s/0$//;
	$self->{matrix}{$layer}{xscale} =~ s/.0$//;
	$self->{matrix}{$layer}{yscale} =~ s/0$//;
	$self->{matrix}{$layer}{yscale} =~ s/.0$//;


	$self->{matrix}{$anther}{xscale} =  $self->{matrix}{$layer}{xscale};
	$self->{matrix}{$anther}{yscale} =  $self->{matrix}{$layer}{yscale};


}
	
											






#===================================================================
#===================================================================
1;

